unit MainForm;

interface

uses
  Windows, Classes, Controls, Forms, SysUtils, ComCtrls,
  Dialogs, U_Inspector, StdCtrls, U_Exchange, U_Dialog_Compare, U_HExaDeci,
  U_HexEdit, ImgList, ShellCtrls, Unit2,
  U_Dialog_DatabaseEdit, U_Dialog_Scan, KeyLib;


type
  TForm1 = class(TForm)
    OD_File: TOpenDialog;
    B_Inspector: TButton;
    B_Compare: TButton;
    B_SDBCreate: TButton;
    B_SDBEdit: TButton;
    B_SDBRename: TButton;
    FR_Imgs: TImageList;
    GB_FileBrowser: TGroupBox;
    STV_FileBrowser: TShellTreeView;
    B_About: TButton;
    Edit1: TEdit;
    procedure B_InspectorClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure B_CompareClick(Sender: TObject);
    procedure B_SDBCreateClick(Sender: TObject);
    procedure STV_FileBrowserAddFolder(Sender: TObject;
      AFolder: TShellFolder; var CanAdd: Boolean);
    procedure B_SDBEditClick(Sender: TObject);
    procedure B_AboutClick(Sender: TObject);
    procedure B_SDBRenameClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    enablesave:boolean;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.B_InspectorClick(Sender: TObject);
var shit:TDI_Inspector;
    OD:TOpenDialog;
    s:string;
    l,lst:longword;
begin
    if not STV_FileBrowser.SelectedFolder.IsFolder then begin
      s:=STV_FileBrowser.SelectedFolder.PathName;
      TDI_Inspector_Open.FileName:=s;
      shit:=TDI_Inspector.Create(Application);
      shit.Show;
      Form1.BringToFront;
      lst:=0; while L_Inspector[lst]<>NIL do inc(lst);
      L_Inspector[lst]:=shit;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var ri:reginfo;
    rr:byte;
    s:string;
begin
  fillchar(L_Inspector,$400,0);
  fillchar(L_Hex,sizeof(L_Hex),0);
  fillchar(L_FileEdit,sizeof(L_FileEdit),0);
  fillchar(L_RangeEdit,sizeof(L_RangeEdit),0);
  fillchar(L_DiskEdit,sizeof(L_DiskEdit),0);
  fillchar(L_VersionEdit,sizeof(L_VersionEdit),0);
  fillchar(L_GameEdit,sizeof(L_GameEdit),0);
  fillchar(L_DataBaseEdit,sizeof(L_DataBaseEdit),0);
  rr:=KS_GetRegInfo('adfren.key',ri,NIL,0);
  enablesave:=FALSE;
  if rr<>0 then begin
    B_SDBCreate.Enabled:=FALSE;
    B_SDBEdit.Enabled:=FALSE;
  end else begin
    if ri.prodid=$adf00001 then begin
      s:='Registered to '+ri.Name+' ('+ri.Mail+') [Ser#'+hexa(ri.serial,8)+']';
      Edit1.Text:=s;
      enablesave:=TRUE;
    end else begin
      B_SDBCreate.Enabled:=FALSE;
      B_SDBEdit.Enabled:=FALSE;
    end;
  end;
end;

procedure TForm1.B_CompareClick(Sender: TObject);
var TC:TF_Compare;
begin
  TC:=TF_Compare.Create(self);
  TC.Show;
end;

procedure TForm1.B_SDBCreateClick(Sender: TObject);
var shit:TF_DatabaseEdit;
    s:string;
begin
  OD_File.Options:=[ofAllowMultiSelect, ofPathMustExist, ofEnableSizing, ofOverWritePrompt];
  OD_File.InitialDir:='c:\';
  OD_File.Title:='Create a DID file';
  OD_File.Filter:='Disk Image Database (*.did)|*.did';
  if OD_File.Execute then begin
    s:=OD_File.FileName;
    if Copy(UpcaseStr(s),length(s)-3,4)<>'.DID' then s:=s+'.did';
    Open_DataBaseEdit.createnew:=TRUE;
    Open_DataBaseEdit.filename:=s;
    shit:=TF_DatabaseEdit.Create(self);
    shit.show;
    shit.saveenable:=enablesave;
  end;
end;

function UpcaseStr(s:string):string;
var l:longword;
begin
  for l:=1 to length(s) do s[l]:=upcase(s[l]);
  UpcaseStr:=s;
end;

procedure TForm1.STV_FileBrowserAddFolder(Sender: TObject;
  AFolder: TShellFolder; var CanAdd: Boolean);
begin
  if AFolder.IsFolder then begin
    CanAdd:=(copy(AFolder.PathName,1,2)<>'A:') and (copy(AFolder.PathName,1,2)<>'B:');
  end else begin
    CanAdd:=(UpcaseStr(Copy(AFolder.PathName,length(AFolder.PathName)-3,4))='.ADF') OR
            (UpcaseStr(Copy(AFolder.PathName,length(AFolder.PathName)-3,4))='.ZIP');
  end;
end;

procedure TForm1.B_SDBEditClick(Sender: TObject);
var shit:TF_DatabaseEdit;
    s:string;
begin
  OD_File.Options:=[ofAllowMultiSelect, ofFileMustExist, ofPathMustExist, ofEnableSizing, ofOverWritePrompt];
  OD_File.InitialDir:='c:\';
  OD_File.Title:='Open a DID file';
  OD_File.Filter:='Disk Image Database (*.did)|*.did';
  if OD_File.Execute then begin
    s:=OD_File.FileName;
    if Copy(UpcaseStr(s),length(s)-3,4)<>'.DID' then s:=s+'.did';
    Open_DataBaseEdit.createnew:=FALSE;
    Open_DataBaseEdit.filename:=s;
    shit:=TF_DatabaseEdit.Create(self);
    shit.show;
    shit.saveenable:=enablesave;
  end;
end;

procedure TForm1.B_AboutClick(Sender: TObject);
begin
  Form2:=TForm2.Create(Self);
  Form2.Show;
end;

procedure TForm1.B_SDBRenameClick(Sender: TObject);
var TS:TF_Scan;
    s:string;
begin
  OD_File.Options:=[ofAllowMultiSelect, ofFileMustExist, ofPathMustExist, ofEnableSizing, ofOverWritePrompt];
  OD_File.InitialDir:='c:\';
  OD_File.Title:='Open a DID file';
  OD_File.Filter:='Disk Image Database (*.did)|*.did';
  if OD_File.Execute then begin
    s:=OD_File.FileName;
    if Copy(UpcaseStr(s),length(s)-3,4)<>'.DID' then s:=s+'.did';
    Open_Scan_filename:=s;
    TS:=TF_Scan.Create(self);
    TS.Show;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
var s1,s2:string;
begin
end;

end.
