 Unit U_ADF;

 interface

   const BT_Unused  : longword =  $00;
         BT_Root    : longword =  $01;
         BT_Dir     : longword =  $02;
         BT_FileH   : longword =  $03;
         BT_HLink   : longword =  $04;
         BT_SLink   : longword =  $05;
         BT_FExt    : longword =  $06;
         BT_Data    : longword =  $07;
         BT_DirC    : longword =  $08;
         BT_Unform  : longword =  $0d;
         BT_Boot1   : longword =  $0e;
         BT_Boot2   : longword =  $0f;
         BT_ChksErr : longword =  $10;
         BT_ReadErr : longword =  $20;
         BT_Recurse : longword =  $40;
         BT_Verified: longword =  $80;
         BT_BadType : longword = $100;
         BT_BadSeq  : longword = $200;
         BT_Selected: longword = $400;
         BT_Inspect : longword = $800;

         OM_ReadWrite : longword = $01;
         OM_ReadOnly  : longword = $02;

         ST_Init     : longword =  $01;
         ST_Opened   : longword =  $02;
         ST_ReadOnly : longword =  $04;
         ST_Changed  : longword =  $08;
         ST_DOS      : longword =  $10;
         ST_FFS      : longword =  $20;
         ST_INTL     : longword =  $40;
         ST_DirC     : longword =  $80;

   type tBA=array[0..$fffffff] of byte;
        tBW=array[0..$fffffff] of word;
        tBL=array[0..$fffffff] of longword;

   type pADF=^tADF;
        tADF=record
          fn:string;
          status:longword;
          mode:longword;
          buffs:longword;
          buffb:^tBA;
          buffw:^tBW;
          buffl:^tBL;
          FFS:boolean;
          INTL:boolean;
          DIRC:boolean;
        end;

   type pBootBlock=^tBootBlock;
        tBootBlock=record
          DiskType:longword;
          ChkSum:longword;
          RootBlock:longword;
          Code:array[$000..$3f3] of byte;
        end;

   type pRootBlock=^tRootBlock;
        tRootBlock=record
          PrimType:longword;
          HeaderKey:longword;
          HighSeq:longword;
          HTSize:longword;
          FirstData:longword;
          ChkSum:longword;
          HT:array[$00..$47] of longword;
          BMFlag:longword;
          BMPages:array[$00..$18] of longword;
          BMExt:longword;
          RD:longword;
          RM:longword;
          RT:longword;
          Name:string[$1f];
          Unused1:longword;
          Unused2:longword;
          VD:longword;
          VM:longword;
          VT:longword;
          DD:longword;
          DM:longword;
          DT:longword;
          NextHash:longword;
          ParentDir:longword;
          Extension:longword;
          SecType:longword;
        end;

   type pBitmapBlock=^tBitmapBlock;
        tBitmapBlock=record
          ChkSum:longword;
          Map:array[$00..$7e] of longword;
        end;

   type pBitmapExtBlock=^tBitmapExtBlock;
        tBitmapExtBlock=record
          Map:array[$00..$7e] of longword;
          Next:longword; { 0 = last }
        end;

   type pFileHeaderBlock=^tFileHeaderBlock;
        tFileHeaderBlock=record
          PrimType:longword;
          HeaderKey:longword;
          HighSeq:longword;
          DataSize:longword;
          FirstData:longword;
          ChkSum:longword;
          DataBlocks:array[$00..$47] of longword;
          Unused1:longword;
          UID:word;{!!!!}
          GID:word;
          Protect:longword;
          Size:longword;
          Comment:string[$4f];
          Unused2:array[$00..$02] of longword;
          RD:longword;
          RM:longword;
          RT:longword;
          Name:string[$1f];
          Unused3:longword;
          RealEntry:longword;
          NextLink:longword;
          Unused4:array[$00..$04] of longword;
          NextHash:longword;
          ParentDir:longword;
          Extension:longword;
          SecType:longword;
        end;

   type pFileExtBlock=^tFileExtBlock;
        tFileExtBlock=record
          PrimType:longword;
          HeaderKey:longword;
          HighSeq:longword;
          Unused1:array[$00..$01] of longword;
          ChkSum:longword;
          DataBlocks:array[$00..$47] of longword;
          Unused2:array[$00..$2d] of longword;
          Unused3:longword;
          Parent:longword;
          Extension:longword;
          SecType:longword;
        end;

   type pFileDataBlock=^tFileDataBlock;
        tFileDataBlock=record
          PrimType:longword;
          HeaderKey:longword;
          HighSeq:longword;
          DataSize:longword;
          NextData:longword;
          ChkSum:longword;
          Data:array[$000..$1e7] of byte;
        end;

   type pDirBlock=^tDirBlock;
        tDirBlock=record
          PrimType:longword;
          HeaderKey:longword;
          Unused1:array[$00..$02] of longword;
          ChkSum:longword;
          HT:array[$00..$47] of longword;
          Unused2:longword;
          UID:word;
          GID:word;
          Protect:longword;
          Unused3:longword;
          Comment:string[$4f];
          Unused4:array[$00..$02] of longword;
          RD:longword;
          RM:longword;
          RT:longword;
          Name:string[$1f];
          Unused5:array[$00..$01] of longword;
          NextLink:longword;
          Unused6:array[$00..$04] of longword;
          NextHash:longword;
          ParentDir:longword;
          Extension:longword;
          SecType:longword;
        end;

   type pHardLinkBlock=^tHardLinkBlock;
        tHardLinkBlock=record
          PrimType:longword;
          HeaderKey:longword;
          Unused1:array[$00..$02] of longword;
          ChkSum:longword;
          Unused2:array[$00..$49] of longword;
          Protect:longword;
          Unused3:longword;
          Comment:string[$4f];
          Unused4:array[$00..$02] of longword;
          RD:longword;
          RM:longword;
          RT:longword;
          Name:string[$1f];
          Unused5:longword;
          RealEntry:longword;
          NextLink:longword;
          Unused6:array[$00..$04] of longword;
          NextHash:longword;
          ParentDir:longword;
          Unused7:longword;
          SecType:longword;
        end;

   type pSoftLinkBlock=^tSoftLinkBlock;
        tSoftLinkBlock=record
          PrimType:longword;
          HeaderKey:longword;
          Unused1:array[$00..$02] of longword;
          ChkSum:longword;
          SymbolicName:array[$000..$11f] of char;
          Unused2:array[$00..$01] of longword;
          Protect:longword;
          Unused3:longword;
          Comment:string[$4f];
          Unused4:array[$00..$02] of longword;
          RD:longword;
          RM:longword;
          RT:longword;
          Name:string[$1f];
          Unused5:longword;
          RealEntry:longword;
          NextLink:longword;
          Unused6:array[$00..$04] of longword;
          NextHash:longword;
          ParentDir:longword;
          Unused7:longword;
          SecType:longword;
        end;

   const LE_None     : longword = $00;
         LE_OpenFail : longword = $01;
         LE_SaveFail : longword = $02;

   var LE:longword;

   const FA_DeleteForbidden : word = $001;
         FA_NotExecutable   : word = $002;
         FA_NotWritable     : word = $004;
         FA_NotReadable     : word = $008;
         FA_Archived        : word = $010;
         FA_Pure            : word = $020;
         FA_Script          : word = $040;
         FA_Hold            : word = $080;
         FA_Directory       : word = $100;

   type pSR=record
              find:string;
              attr:longword;
              root:longword;
              bls:longword;
              blp:^tBA;
            end;

   procedure ADF_FlipLong(var l:longword);
   function ADF_CalcChecksum(var X; XSize:longword; CheckSumPos:longword; Method:longword):longword;
   function ADF_Open(fn:string; mode:longword):pADF;
   procedure ADF_Close(p:pADF);

   procedure ADF_Uppercase(var s:string; intl:boolean);
   function ADF_GetHash(FN:string):word;
   function ADF_GetBlockType(var p:pADF; bn:longword):longword;

   implementation

   uses sinflate;
   procedure ADF_FlipLong(var l:longword);
     var b1:array[0..3] of byte;
         b2:array[0..3] of byte;
     begin
       move(l,b1,4);
       b2[0]:=b1[3]; b2[1]:=b1[2]; b2[2]:=b1[1]; b2[3]:=b1[0];
       move(b2,l,4);
     end;

   function ADF_CalcChecksum(var X; XSize:longword; CheckSumPos:longword; Method:longword):longword;
   { method 0 = bootblock, method 1 = rootblock }
     var newcarry,carry:longword;
         CSbuf:array[$00..$03] of byte;
         Data:array[$000..$3ff] of byte;
         oldchecksum,newchecksum:longword;
         l0,l1:longword;
     begin
       move(x,Data,xSize);
       fillchar(CSBuf,$04,$00);
       if method=1 then CSBuf[3]:=0;
       carry:=0; newcarry:=0;
       for l0:=$00 to (XSize-1) div 4+1 do begin { +1 for possible left-over }
         if (l0=(XSize-1) div 4+1) then for l1:=$03 downto $00 do begin
           if CSBuf[l1]+carry>=$100 then newcarry:=$01 else newcarry:=$00;
           CSBuf[l1]:=CSBuf[l1]+carry;
           if (method=0) or (l1>0) then carry:=newcarry else carry:=0;
         end else
         if l0<>CheckSumPos div 4 then for l1:=$03 downto $00 do begin
           if CSBuf[l1]+Data[l0*$04+l1]+carry>=$100 then newcarry:=$01 else newcarry:=$00;
           CSBuf[l1]:=CSBuf[l1]+Data[l0*$04+l1]+carry;
           if (method=0) or (l1>0) then carry:=newcarry else carry:=0;
         end;
       end;
       move(CSBuf,newchecksum,4);
       if method=0 then ADF_CalcCheckSum:=not NewCheckSum else begin
         ADF_FlipLong(newchecksum);
         newchecksum:=-newchecksum;
         ADF_FlipLong(newchecksum);
         ADF_CalcCheckSum:=NewCheckSum;
       end;
     end;

   var DEF_input:^tBA;
       DEF_inputpos:longword;
       DEF_inputsize:longword;
       DEF_output:^tBA;
       DEF_outputsize:longword;
       DEF_outputpos:longword;

   function MyRead:byte;
   begin
     MyRead:=DEF_input^[DEF_inputpos];
     inc(DEF_inputpos);
     if DEF_inputpos=DEF_inputsize then SI_BREAK:=TRUE;
   end;

   procedure MyWrite(amount:word);
   begin
     move(SI_WINDOW^,DEF_Output^[DEF_outputpos],amount);
     inc(DEF_Outputpos,amount);
   end;

   function ADF_Open(fn:string; mode:longword):pADF;
     var p:pADF;
         f:file;
         compdata:pointer;
         comppos:pointer;
         compsize:longword;
         uncompsize:longword;
         l0,l1:longword;
         w0,w1:word;
     begin
       assign(f,fn); filemode:=$40; {$I-} reset(f,1); {$I+}
       if ioresult=0 then begin
        { ZIP file? }
         blockread(f,l0,$04);
         seek(f,0);
         if l0=$04034b50 then begin
           seek(f,$12);
           blockread(f,compsize,$04); blockread(f,uncompsize,$04);
           blockread(f,w0,$02); blockread(f,w1,$02);
           seek(f,$1e+w0+w1);
           Getmem(DEF_input,compsize);
           Getmem(DEF_output,uncompsize);
           DEF_inputpos:=0;
           DEF_inputsize:=compsize;
           DEF_outputpos:=0;
           DEF_outputsize:=uncompsize;
           blockread(f,DEF_input^,compsize);
           close(f);
           SI_READ:=MyRead;
           SI_WRITE:=MyWrite;
           SI_INFLATE;
           new(p);
           p^.fn:=fn;
           p^.mode:=mode;
           p^.buffs:=uncompsize;
           p^.buffb:=@DEF_output^;
           p^.buffw:=@p^.buffb^;
           p^.buffl:=@p^.buffb^;
           LE:=LE_None;
           ADF_Open:=p;
           Freemem(DEF_Input,compsize);
         end else begin
           new(p);
           p^.fn:=fn;
           p^.mode:=mode;
           p^.buffs:=filesize(f);
           getmem(p^.buffb,p^.buffs);
           p^.buffw:=@p^.buffb^;
           p^.buffl:=@p^.buffb^;
           blockread(f,p^.buffb^,p^.buffs);
           close(f);
           LE:=LE_None;
           ADF_Open:=p;
         end;
       end else LE:=LE_OpenFail;
     end;

   procedure ADF_Close(p:pADF);
     var f:file;
     begin
       if (p^.mode=OM_ReadWrite) and (1=0) then begin
         assign(f,p^.fn); filemode:=$42; {$I-} rewrite(f,1); {$I+}
         if ioresult=0 then begin
           blockwrite(f,p^.buffb^,p^.buffs);
           close(f);
           freemem(p^.buffb,p^.buffs);
           dispose(p);
           p:=NIL;
           LE:=LE_None;
         end else LE:=LE_SaveFail;
       end else begin
         freemem(p^.buffb,p^.buffs);
         dispose(p);
         p:=NIL;
         LE:=LE_None;
       end;
     end;

{   const FA_DeleteForbidden : word = $001;
         FA_NotExecutable   : word = $002;
         FA_NotWritable     : word = $004;
         FA_NotReadable     : word = $008;
         FA_Archived        : word = $010;
         FA_Pure            : word = $020;
         FA_Script          : word = $040;
         FA_Hold            : word = $080;
         FA_Directory       : word = $100;

   type pSR=record
              find:string;
              attr:longword;
              root:longword;
              bls:longword;
              blp:^tBA;
            end;}

   procedure ADF_Uppercase(var s:string; intl:boolean);
     var l:byte;
     begin
       for l:=$01 to length(s) do begin
         s[l]:=upcase(s[l]);
         if intl and (Byte(s[l])>=224) and (Byte(s[l])<=254) and (Byte(s[l])<>247) then dec(s[l],$20);
       end;
     end;

  function ADF_GetHash(FN:string):word;
     var HashVal,l:longword;
     begin
       HashVal:=length(FN);
       for l:=1 to length(FN) do begin
         HashVal:=HashVal*13;
         HashVal:=HashVal+Byte(FN[l]);
         HashVal:=HashVal and $07ff;
       end;
       HashVal:=HashVal mod $48;
       ADF_GetHash:=HashVal;
     end;

   function ADF_GetBlockType(var p:pADF; bn:longword):longword;
     var bt:longword;
     begin
       if p^.buffl^[bn*$80]=$02000000 then begin
         if p^.buffl^[bn*$80+$7f]=$01000000 then bt:=BT_Root else
         if p^.buffl^[bn*$80+$7f]=$02000000 then bt:=BT_Dir else
         if p^.buffl^[bn*$80+$7f]=$fdffffff then bt:=BT_FileH else
         if p^.buffl^[bn*$80+$7f]=$04000000 then bt:=BT_HLink else
         if p^.buffl^[bn*$80+$7f]=$fcffffff then bt:=BT_HLink else
         if p^.buffl^[bn*$80+$7f]=$03000000 then bt:=BT_SLink else
       end else
       if p^.buffl^[bn*$80]=$10000000 then bt:=BT_FExt else
       if p^.buffl^[bn*$80]=$08000000 then bt:=BT_Data else
       if p^.buffl^[bn*$80]=$21000000 then bt:=BT_DirC else bt:=BT_Unused;
       if bt<>BT_Unused then begin
         if ADF_CalcChecksum(p^.buffl^[bn*$80],$200,$14,1)<>p^.buffl^[bn*$80+$05] then begin
           bt:=bt or BT_ChksErr;
         end;
       end;
       ADF_GetBlockType:=bt;
     end;

   end.
