Unit U_CRC32;

 INTERFACE

 Procedure CRCbuildtable;
 Procedure CRCstart(Var CRC:LongWord);
 Procedure CRCadd(Var CRC:LongWord; B:Byte);
 Procedure CRCaddbuffer(Var CRC:LongWord; Var BUF; Len:LongWord);
 Procedure CRCend(Var CRC:LongWord);

 IMPLEMENTATION

 Const CRCpol=$edb88320;
 Var   CRCtab:Array [$00..$ff] of LongWord;

 Procedure CRCbuildtable;
   Var W0,W1:Byte;
       CRC:LongWord;
   Begin
    FillChar(CRCtab,SizeOf(CRCtab),0);
    For W0:=0 to 255 do begin
     CRC:=LongInt(W0) shl 1;
     For W1:=8 downto 0 do If (CRC and 1)=1 then CRC:=(CRC shr 1) xor CRCpol
                                            else CRC:=CRC shr 1;
     CRCtab[W0]:=CRC;
    end;
   End;

 Procedure CRCadd(Var CRC:LongWord; B:Byte);
   Begin
    CRC:=CRCtab[byte(crc xor longword(b))] xor ((CRC shr 8){ and $00ffffff});
   End;

 Procedure CRCaddbuffer(Var CRC:LongWord; Var BUF; Len:LongWord);
   Type BUFP=Array [0..65534] of Byte;
   Var W:LongWord;
       BP:^BUFP;
       CB:^Byte;
   Begin
    If LEN>0 then begin
      BP:=@BUF; CB:=@CRC;
      For W:=0 to LEN-1 do CRC:=CRCtab[CB^ xor BP^[W]] xor (CRC shr 8);
    end;
   End;

 Procedure CRCstart(Var CRC:LongWord);
   Begin
    CRC:=$ffffffff;
   End;

 Procedure CRCend(Var CRC:LongWord);
   Begin
    CRC:=CRC xor ($ffffffff);
   End;

 Begin
  CRCbuildtable;
 End.

