unit U_Dialog_Compare;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, U_ADF, U_CRC32, U_HexaDeci, U_Exchange, U_Inspector,
  ComCtrls, ImgList;

type
  TF_Compare = class(TForm)
    FS_List: TListView;
    GB_FileStats: TGroupBox;
    GB_RangeStats: TGroupBox;
    RS_List: TListView;
    GB_ADF: TGroupBox;
    AI_List: TListView;
    B_Compare: TButton;
    FR_Imgs: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure B_CompareClick(Sender: TObject);
    procedure FS_ListResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    TI_List:array[$00..$ff] of TDI_Inspector;
  end;

var
  F_Compare: TF_Compare;

implementation

{$R *.dfm}

procedure TF_Compare.FormCreate(Sender: TObject);
var lst:longword;
    TI:TDI_Inspector;
    IT:TListItem;
    found:longword;
begin
  FillChar(TI_List,sizeof(TI_List),$00);
  AI_List.Items.Clear;
  found:=0;
  for lst:=$00 to $ff do if (L_Inspector[lst]<>NIL) then begin
    TI:=L_Inspector[lst];
    TI_List[found]:=TI;
    IT:=AI_List.Items.Add; IT.Checked:=TRUE;
    IT.Caption:=Hexa(found,2)+': '+TI.ADFName;
    inc(found);
  end;
end;

procedure TF_Compare.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Release;
end;

function UpcaseStr(s:string):string;
var l:longword;
begin
  for l:=1 to length(s) do s[l]:=upcase(s[l]);
  UpcaseStr:=s;
end;

procedure TF_Compare.B_CompareClick(Sender: TObject);
const maxequal:longword=$20;
var crc,itemn,adfn,adfnc,numadf:longword;
    TC:TListColumn;
    NewItem:TListItem;
    tf:array[$00..$ff] of DBE_File;
    ta:array[$00..$ff] of PADF;
    bo,bo2:boolean;
    olds,oldc:longword;
    pbeg,pend:longword;
    newequal,equal:boolean;
    equalcount:longword;
    TLIB,TLI:TListItems;
    compo:longword;
    compol:array[$00..$ff] of byte;
    adfnum:array[$00..$ff] of byte;
    adfnumn:byte;
begin
{ filelist generate }
  FS_List.Hide;
  FS_List.Clear;
  FS_List.Columns.Clear;
  numadf:=0;
  TC:=FS_List.Columns.Add;
  TC.Caption:='Filename';
  TC.Width:=174;
  TC.Alignment:=taLeftJustify;
  while TI_List[numadf]<>NIL do begin
    if AI_List.Items[numadf].Checked then begin
      TC:=FS_List.Columns.Add;
      TC.Caption:=hexa(numadf,2)+'-size';
      TC.Width:=50;
      TC.Alignment:=taRightJustify;
      TC:=FS_List.Columns.Add;
      TC.Caption:=hexa(numadf,2)+'-crc32';
      TC.Width:=68;
      TC.Alignment:=taRightJustify;
    end;
    inc(numadf);
  end;
  for adfn:=0 to numadf-1 do if AI_List.Items[adfn].Checked then begin
    tf[adfn]:=TI_List[adfn].Files;
    while tf[adfn]<>NIL do begin
      bo:=FALSE;
      if (FS_List.Items.Count>0) then for itemn:=0 to FS_List.Items.Count-1 do if UpcaseStr(FS_List.Items.Item[itemn].Caption)=UpcaseStr(tf[adfn]^.Name) then bo:=TRUE;
      if not bo then begin
       { Add Item }
        NewItem:=FS_List.Items.Add;
        NewItem.Caption:=tf[adfn]^.Name;
        { Calculate Subitems }
        olds:=tf[adfn]^.Size;
        oldc:=tf[adfn]^.CRC32;
        bo2:=TRUE;
        for adfnc:=0 to numadf-1 do begin
          if adfnc=adfn then begin
            NewItem.SubItems.Add(IntToStr(tf[adfn]^.size));
            NewItem.SubItems.Add(Hexa(tf[adfn]^.crc32,8));
            if tf[adfnc]^.size<>olds then bo2:=FALSE;
            if tf[adfnc]^.crc32<>oldc then bo2:=FALSE;
          end else if AI_List.Items[adfnc].Checked then begin
            tf[adfnc]:=TI_List[adfnc].Files;
            bo:=FALSE;
            while not bo do begin
              if tf[adfnc]<>NIL then begin
                if UpcaseStr(tf[adfnc]^.Name)=UpcaseStr(tf[adfn]^.Name) then bo:=TRUE else begin
                  tf[adfnc]:=tf[adfnc]^.Next;
                end;
              end else bo:=TRUE;
            end;
            if tf[adfnc]<>NIL then begin
              NewItem.SubItems.Add(IntToStr(tf[adfnc]^.size));
              NewItem.SubItems.Add(Hexa(tf[adfnc]^.crc32,8));
              if tf[adfnc]^.size<>olds then bo2:=FALSE;
              if tf[adfnc]^.crc32<>oldc then bo2:=FALSE;
            end else begin
              NewItem.SubItems.Add('--');
              NewItem.SubItems.Add('--');
              bo2:=FALSE;
            end;
          end;
        end;
        if bo2 then NewItem.ImageIndex:=0 else NewItem.ImageIndex:=1;
      end;
      tf[adfn]:=tf[adfn]^.next;
    end;
  end;
  FS_List.AlphaSort;
{ rangelist generate }
  RS_List.Clear;
  RS_List.Columns.Clear;
  RS_List.Hide;
  numadf:=0;
  TC:=RS_List.Columns.Add;
  TC.Caption:='Start';
  TC.Width:=78;
  TC.Alignment:=taLeftJustify;
  TC:=RS_List.Columns.Add;
  TC.Caption:='End';
  TC.Width:=66;
  TC.Alignment:=taLeftJustify;
 { fill column headers }
  while TI_List[numadf]<>NIL do begin
    if AI_List.Items[numadf].Checked then begin
      TC:=RS_List.Columns.Add;
      TC.Caption:=hexa(numadf,2)+'-crc32';
      TC.Width:=68;
      TC.Alignment:=taRightJustify;
      ta[numadf]:=TI_List[numadf].ADF;
     end;
    inc(numadf);
  end;
 { compare links generation }
  adfnumn:=0;
  for adfn:=0 to numadf-1 do begin
    if AI_List.Items[adfn].Checked then begin
      adfnum[adfnumn]:=adfn;
      inc(adfnumn);
      if adfn<numadf-1 then compo:=adfn+1 else compo:=0;
      while not AI_List.Items[compo].Checked do begin
        inc(compo);
        if compo=numadf then compo:=0;
      end;
      compol[adfn]:=compo;
    end;
  end;
  newequal:=TRUE;
  equalcount:=0;
  pbeg:=0;
  pend:=0;
 { master equality check }
  for adfn:=0 to adfnumn-1 do if ta[adfnum[adfn]]^.buffb^[pend]<>ta[compol[adfnum[adfn]]]^.buffb^[pend] then newequal:=FALSE;
  equal:=newequal;
  while pend<22*80*$200 do begin
    newequal:=TRUE;
   { check for equality }
    for adfn:=0 to adfnumn-1 do if ta[adfnum[adfn]]^.buffb^[pend]<>ta[compol[adfnum[adfn]]]^.buffb^[pend] then newequal:=FALSE;
    if not newequal then equalcount:=0;
    if (newequal) and (not equal) then inc(equalcount);
    if ((equal) and (not newequal)) or ((not equal) and (equalcount>maxequal)) then begin
     { Add Item }
      equalcount:=0;
      if (not equal) then pend:=pend-maxequal;
      dec(pend);
      NewItem:=RS_List.Items.Add;
      NewItem.Caption:=hexa(pbeg,8);
      NewItem.SubItems.Add(hexa(pend,8));
      if equal then NewItem.ImageIndex:=0 else NewItem.ImageIndex:=1;
      for adfn:=0 to adfnumn-1 do begin
        CRCstart(crc);
        CRCaddbuffer(crc,ta[adfnum[adfn]]^.buffb^[pbeg],pend-pbeg+1);
        CRCend(crc);
        NewItem.SubItems.Add(Hexa(crc,8));
      end;
      equal:=not equal;
      inc(pend);
      pbeg:=pend;
    end;
    inc(pend);
  end;

  dec(pend);
  NewItem:=RS_List.Items.Add;
  NewItem.Caption:=hexa(pbeg,8);
  NewItem.SubItems.Add(hexa(pend,8));
  if equal then NewItem.ImageIndex:=0 else NewItem.ImageIndex:=1;
  for adfn:=0 to adfnumn-1 do begin
    CRCstart(crc);
    CRCaddbuffer(crc,ta[adfnum[adfn]]^.buffb^[pbeg],pend-pbeg+1);
    CRCend(crc);
    NewItem.SubItems.Add(Hexa(crc,8));
  end;
  FS_List.Show;
  RS_List.Show;
end;

procedure TF_Compare.FS_ListResize(Sender: TObject);
begin
  AI_List.Columns.Items[0].Width:=AI_List.Width-20;
end;

end.
