unit U_Dialog_GameEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, U_Exchange;

var open_gameedit_data:DB_Soft;

type
  TF_GameEdit = class(TForm)
    GB_StandardInfo: TGroupBox;
    GB_Credits: TGroupBox;
    GB_Comment: TGroupBox;
    ST_Name: TStaticText;
    ED_Name: TEdit;
    ED_Publisher: TEdit;
    ED_RelYear: TEdit;
    ED_RelMonth: TEdit;
    ED_RelDay: TEdit;
    ED_Developer: TEdit;
    ST_Developer: TStaticText;
    ST_Code: TStaticText;
    ED_Code: TEdit;
    ST_Graphics: TStaticText;
    ED_Graphics: TEdit;
    ST_SoundFX: TStaticText;
    ED_SoundFX: TEdit;
    ST_Music: TStaticText;
    ED_Music: TEdit;
    ST_Design: TStaticText;
    ED_Design: TEdit;
    M_Comment: TMemo;
    ST_Publisher: TStaticText;
    ST_RelDate: TStaticText;
    B_Okay: TButton;
    B_Save: TButton;
    B_Cancel: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure B_OkayClick(Sender: TObject);
    procedure B_SaveClick(Sender: TObject);
    procedure B_CancelClick(Sender: TObject);
  private
    procedure DBToScreen;
    procedure ScreenToDB;
    { Private declarations }
  public
    DB:DB_Soft;
    SaveOnClose:boolean;
    { Public declarations }
  end;

implementation

{$R *.dfm}

procedure TF_GameEdit.DBToScreen;
begin
  M_Comment.Clear;
  if DB^.comment<>NIL then M_Comment.Lines.Add(GetPSString(DB^.comment));
  if DB^.publisher<>NIL then ED_Publisher.Text:=DB.publisher^;
  if DB^.gamename<>NIL then ED_Name.Text:=DB.gamename^;
  if DB^.developer<>NIL then ED_Developer.Text:=DB.developer^;
  if DB^.programm<>NIL then ED_Code.Text:=DB.programm^;
  if DB^.graphics<>NIL then ED_Graphics.Text:=DB.graphics^;
  if DB^.soundfx<>NIL then ED_SoundFX.Text:=DB.soundfx^;
  if DB^.music<>NIL then ED_Music.Text:=DB.music^;
  if DB^.design<>NIL then ED_Design.Text:=DB.design^;
  ED_RelYear.Text:=IntToStr(DB.releaseyear);
  ED_RelMonth.Text:=IntToStr(DB.releasemonth);
  ED_RelDay.Text:=IntToStr(DB.releaseday);
end;

procedure TF_GameEdit.ScreenToDB;
begin
  SetPSString(DB^.comment,MemoToString(M_Comment));
  SetPSString(DB^.publisher,ED_Publisher.Text);
  SetPSString(DB^.gamename,ED_Name.Text);
  SetPSString(DB^.developer,ED_Developer.Text);
  SetPSString(DB^.programm,ED_Code.Text);
  SetPSString(DB^.graphics,ED_Graphics.Text);
  SetPSString(DB^.soundfx,ED_SoundFX.Text);
  SetPSString(DB^.music,ED_Music.Text);
  SetPSString(DB^.design,ED_Design.Text);
  DB^.releaseyear:=StrToInt(ED_RelYear.Text);
  DB^.releasemonth:=StrToInt(ED_RelMonth.Text);
  DB^.releaseday:=StrToInt(ED_RelDay.Text);
end;

procedure TF_GameEdit.FormCreate(Sender: TObject);
var n:byte;
begin
  SaveOnClose:=TRUE;
  DB:=open_gameedit_data;
  DBToScreen;
  n:=0;
  while L_GameEdit[n].inst<>NIL do inc(n);
  L_GameEdit[n].db:=DB;
  L_GameEdit[n].inst:=self;
  L_GameEdit[n].ready:=FALSE;
end;

procedure TF_GameEdit.FormClose(Sender: TObject; var Action: TCloseAction);
var n:byte;
begin
  if SaveOnClose then ScreenToDB;
  n:=0;
  while L_GameEdit[n].inst<>self do inc(n);
  L_GameEdit[n].ready:=TRUE;
  Release;
end;

procedure TF_GameEdit.B_OkayClick(Sender: TObject);
begin
  SaveOnClose:=TRUE;
  Self.Close;
end;

procedure TF_GameEdit.B_SaveClick(Sender: TObject);
begin
  ScreenToDB;
  DBToScreen;
end;

procedure TF_GameEdit.B_CancelClick(Sender: TObject);
begin
  SaveOnClose:=FALSE;
  Self.Close;
end;

end.
