unit U_Dialog_RangeEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, U_Exchange, U_HexaDeci;

var open_rangeedit_multi:boolean;
    open_rangeedit_pat:array[$000..$fff] of boolean;
    open_rangeedit_data:pointer;

type
  TF_RangeEdit = class(TForm)
    GB_StandardInfo: TGroupBox;
    ST_StartEnd: TLabel;
    ST_SizeCRC: TLabel;
    ST_Description: TLabel;
    ED_Crc32: TEdit;
    ED_Description: TEdit;
    ED_Start: TEdit;
    ED_End: TEdit;
    B_Okay: TButton;
    B_Save: TButton;
    B_Cancel: TButton;
    GB_Details: TGroupBox;
    L_Primary: TLabel;
    L_Secondary: TLabel;
    L_Flags: TLabel;
    L_Descriptors: TLabel;
    C_Boot: TCheckBox;
    C_PreGame: TCheckBox;
    C_Game: TCheckBox;
    C_Addendum: TCheckBox;
    C_Unused: TCheckBox;
    C_Shared: TCheckBox;
    C_Exclude: TCheckBox;
    C_Highscores: TCheckBox;
    C_Savegame: TCheckBox;
    C_Sound: TCheckBox;
    C_Graphics: TCheckBox;
    C_Subcode: TCheckBox;
    C_Custom: TCheckBox;
    C_Docs: TCheckBox;
    C_HDInstall: TCheckBox;
    C_Trainer: TCheckBox;
    C_Cracktro: TCheckBox;
    C_Releasetro: TCheckBox;
    C_Dynsize: TCheckBox;
    C_Dynamic: TCheckBox;
    C_WB: TCheckBox;
    C_Optional: TCheckBox;
    C_Code: TCheckBox;
    C_Load: TCheckBox;
    procedure B_OkayClick(Sender: TObject);
    procedure B_SaveClick(Sender: TObject);
    procedure B_CancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    Multi:boolean;
    Pat:array[$000..$fff] of boolean;
    SaveOnClose:boolean;
    DB:DB_Range;
    DBD:DB_Disk;
    procedure ScreenToDB;
    procedure DBToScreen;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  F_RangeEdit: TF_RangeEdit;

implementation

{$R *.dfm}

procedure GetInfoVal(info:longword; pat:longword; var val:boolean; var same:boolean; var first:boolean);
begin
  if first then begin
    if info and pat=pat then val:=TRUE else val:=FALSE;
    same:=TRUE;
  end else begin
    if info and pat=pat then begin if not val then same:=FALSE; end else begin if val then same:=FALSE; end;
  end;
end;

procedure SetCB(same:boolean; val:boolean; var CB:TCheckBox);
begin
  if not same then CB.State:=cbGrayed else begin
    if val then CB.State:=cbChecked else CB.State:=cbUnchecked;
  end;
end;

procedure SetCB2(info:longword; pat:longword; var CB:TCheckBox);
begin
  if info and pat=pat then CB.State:=cbChecked else CB.State:=cbUnchecked;
end;

procedure GetCB(var info:longword; pat:longword; var CB:TCheckBox);
begin
  if CB.State<>cbGrayed then begin
    info:=info and ($ffffffff-pat);
    if CB.State=cbChecked then inc(info,pat);
  end;
end;

procedure TF_RangeEdit.ScreenToDB;
const bit:array[1..13] of longword=
     ($01,$02,$04,$100,$200,$400,$10000,$20000,$40000,$80000,$01000000,$02000000,$80000000);
var c,d:longword;
    first:boolean;
    TDF:DB_Range;
begin
  if multi then begin
    TDF:=DBD^.ranges;
    c:=0;
    while TDF<>NIL do begin
      if pat[c] then begin
        GetCB(TDF^.info,DBI_BOOT,C_BOOT);
        GetCB(TDF^.info,DBI_PREGAME,C_PREGAME);
        GetCB(TDF^.info,DBI_GAME,C_GAME);
        GetCB(TDF^.info,DBI_ADDENDUM,C_ADDENDUM);
        GetCB(TDF^.info,DBI_UNUSED,C_UNUSED);
        GetCB(TDF^.info,DBI_CODE,C_CODE);
        GetCB(TDF^.info,DBI_SUBCODE,C_SUBCODE);
        GetCB(TDF^.info,DBI_GRAPHICS,C_GRAPHICS);
        GetCB(TDF^.info,DBI_SOUND,C_SOUND);
        GetCB(TDF^.info,DBI_CUSTOM,C_CUSTOM);
        GetCB(TDF^.info,DBI_SAVEGAME,C_SAVEGAME);
        GetCB(TDF^.info,DBI_HIGHSCORES,C_HIGHSCORES);
        GetCB(TDF^.info,DBI_EXCLUDE,C_EXCLUDE);
        GetCB(TDF^.info,DBI_SHARED,C_SHARED);
        GetCB(TDF^.info,DBI_OPTIONAL,C_OPTIONAL);
        GetCB(TDF^.info,DBI_WB,C_WB);
        GetCB(TDF^.info,DBI_DYNAMIC,C_DYNAMIC);
        GetCB(TDF^.info,DBI_DYNSIZE,C_DYNSIZE);
        GetCB(TDF^.info,DBI_RELEASETRO,C_RELEASETRO);
        GetCB(TDF^.info,DBI_CRACKTRO,C_CRACKTRO);
        GetCB(TDF^.info,DBI_TRAINER,C_TRAINER);
        GetCB(TDF^.info,DBI_HDINSTALL,C_HDINSTALL);
        GetCB(TDF^.info,DBI_DOCS,C_DOCS);
        GetCB(TDF^.info,DBI_LOAD,C_LOAD);
        if ED_Description.Text<>'' then SetPSString(TDF^.description,ED_Description.Text);
      end;
      inc(c);
      TDF:=TDF^.next;
    end;
  end else begin
    TDF:=DB;
    TDF^.addr1:=Deci(ED_Start.Text);
    TDF^.addr2:=Deci(ED_End.Text);
    TDF^.crc32:=Deci(ED_Crc32.Text);
    SetPSString(TDF^.description,ED_Description.Text);
    GetCB(TDF^.info,DBI_BOOT,C_BOOT);
    GetCB(TDF^.info,DBI_PREGAME,C_PREGAME);
    GetCB(TDF^.info,DBI_GAME,C_GAME);
    GetCB(TDF^.info,DBI_ADDENDUM,C_ADDENDUM);
    GetCB(TDF^.info,DBI_UNUSED,C_UNUSED);
    GetCB(TDF^.info,DBI_CODE,C_CODE);
    GetCB(TDF^.info,DBI_SUBCODE,C_SUBCODE);
    GetCB(TDF^.info,DBI_GRAPHICS,C_GRAPHICS);
    GetCB(TDF^.info,DBI_SOUND,C_SOUND);
    GetCB(TDF^.info,DBI_CUSTOM,C_CUSTOM);
    GetCB(TDF^.info,DBI_SAVEGAME,C_SAVEGAME);
    GetCB(TDF^.info,DBI_HIGHSCORES,C_HIGHSCORES);
    GetCB(TDF^.info,DBI_EXCLUDE,C_EXCLUDE);
    GetCB(TDF^.info,DBI_SHARED,C_SHARED);
    GetCB(TDF^.info,DBI_OPTIONAL,C_OPTIONAL);
    GetCB(TDF^.info,DBI_WB,C_WB);
    GetCB(TDF^.info,DBI_DYNAMIC,C_DYNAMIC);
    GetCB(TDF^.info,DBI_DYNSIZE,C_DYNSIZE);
    GetCB(TDF^.info,DBI_RELEASETRO,C_RELEASETRO);
    GetCB(TDF^.info,DBI_CRACKTRO,C_CRACKTRO);
    GetCB(TDF^.info,DBI_TRAINER,C_TRAINER);
    GetCB(TDF^.info,DBI_HDINSTALL,C_HDINSTALL);
    GetCB(TDF^.info,DBI_DOCS,C_DOCS);
    GetCB(TDF^.info,DBI_LOAD,C_LOAD);
  end;
end;

procedure TF_RangeEdit.DBToScreen;
const bit:array[1..24] of longword=
   (DBI_BOOT,DBI_PREGAME,DBI_GAME,DBI_ADDENDUM,DBI_UNUSED,
    DBI_CODE,DBI_SUBCODE,DBI_GRAPHICS,DBI_SOUND,DBI_CUSTOM,DBI_SAVEGAME,DBI_HIGHSCORES,
    DBI_EXCLUDE,DBI_SHARED,DBI_OPTIONAL,DBI_WB,DBI_DYNAMIC,DBI_DYNSIZE,
    DBI_RELEASETRO,DBI_CRACKTRO,DBI_TRAINER,DBI_HDINSTALL,DBI_DOCS,DBI_LOAD);
var c,d:longword;
    first:boolean;
    val:array[1..24] of boolean;
    same:array[1..24] of boolean;
    TDF:DB_Range;
begin
  if multi then begin
    TDF:=DBD^.ranges;
    ED_Start.Text:='<multi>';
    ED_End.Text:='<multi>';
    ED_CRC32.Text:='<multi>';
    c:=0; first:=TRUE;
    while TDF<>NIL do begin
      if pat[c] then begin
        for d:=1 to 24 do GetInfoVal(TDF^.info,bit[d],val[d],same[d],first);
        FIRST:=FALSE;
      end;
      inc(c);
      TDF:=TDF^.next;
    end;
    SetCB(same[01],val[01],C_BOOT);
    SetCB(same[02],val[02],C_PREGAME);
    SetCB(same[03],val[03],C_GAME);
    SetCB(same[04],val[04],C_ADDENDUM);
    SetCB(same[05],val[05],C_UNUSED);
    SetCB(same[06],val[06],C_CODE);
    SetCB(same[07],val[07],C_SUBCODE);
    SetCB(same[08],val[08],C_GRAPHICS);
    SetCB(same[09],val[09],C_SOUND);
    SetCB(same[10],val[10],C_CUSTOM);
    SetCB(same[11],val[11],C_SAVEGAME);
    SetCB(same[12],val[12],C_HIGHSCORES);
    SetCB(same[13],val[13],C_EXCLUDE);
    SetCB(same[14],val[14],C_SHARED);
    SetCB(same[15],val[15],C_OPTIONAL);
    SetCB(same[16],val[16],C_WB);
    SetCB(same[17],val[17],C_DYNAMIC);
    SetCB(same[18],val[18],C_DYNSIZE);
    SetCB(same[19],val[19],C_RELEASETRO);
    SetCB(same[20],val[20],C_CRACKTRO);
    SetCB(same[21],val[21],C_TRAINER);
    SetCB(same[22],val[22],C_HDINSTALL);
    SetCB(same[23],val[23],C_DOCS);
    SetCB(same[24],val[24],C_LOAD);
  end else begin
    TDF:=DB;
    SetCB2(TDF^.info,DBI_BOOT,C_BOOT);
    SetCB2(TDF^.info,DBI_PREGAME,C_PREGAME);
    SetCB2(TDF^.info,DBI_GAME,C_GAME);
    SetCB2(TDF^.info,DBI_ADDENDUM,C_ADDENDUM);
    SetCB2(TDF^.info,DBI_UNUSED,C_UNUSED);
    SetCB2(TDF^.info,DBI_CODE,C_CODE);
    SetCB2(TDF^.info,DBI_SUBCODE,C_SUBCODE);
    SetCB2(TDF^.info,DBI_GRAPHICS,C_GRAPHICS);
    SetCB2(TDF^.info,DBI_SOUND,C_SOUND);
    SetCB2(TDF^.info,DBI_CUSTOM,C_CUSTOM);
    SetCB2(TDF^.info,DBI_SAVEGAME,C_SAVEGAME);
    SetCB2(TDF^.info,DBI_HIGHSCORES,C_HIGHSCORES);
    SetCB2(TDF^.info,DBI_EXCLUDE,C_EXCLUDE);
    SetCB2(TDF^.info,DBI_SHARED,C_SHARED);
    SetCB2(TDF^.info,DBI_OPTIONAL,C_OPTIONAL);
    SetCB2(TDF^.info,DBI_WB,C_WB);
    SetCB2(TDF^.info,DBI_DYNAMIC,C_DYNAMIC);
    SetCB2(TDF^.info,DBI_DYNSIZE,C_DYNSIZE);
    SetCB2(TDF^.info,DBI_RELEASETRO,C_RELEASETRO);
    SetCB2(TDF^.info,DBI_CRACKTRO,C_CRACKTRO);
    SetCB2(TDF^.info,DBI_TRAINER,C_TRAINER);
    SetCB2(TDF^.info,DBI_HDINSTALL,C_HDINSTALL);
    SetCB2(TDF^.info,DBI_DOCS,C_DOCS);
    SetCB2(TDF^.info,DBI_LOAD,C_LOAD);
    ED_Start.Text:=Hexa(TDF^.addr1,8);
    ED_End.Text:=Hexa(TDF^.addr2,8);
    ED_Crc32.Text:=Hexa(TDF^.crc32,8);
    ED_Description.Text:=GetPSString(TDF^.description);
  end;
end;

procedure TF_RangeEdit.B_OkayClick(Sender: TObject);
begin
  SaveOnClose:=TRUE;
  Self.Close;
end;

procedure TF_RangeEdit.B_SaveClick(Sender: TObject);
begin
  ScreenToDB;
  DBToScreen;
end;

procedure TF_RangeEdit.B_CancelClick(Sender: TObject);
begin
  SaveOnClose:=FALSE;
  Self.Close;
end;

procedure TF_RangeEdit.FormClose(Sender: TObject;
  var Action: TCloseAction);
var n:byte;
begin
  if SaveOnClose then ScreenToDB;
  n:=0;
  while L_RangeEdit[n].inst<>self do inc(n);
  L_RangeEdit[n].ready:=TRUE;
  Release;
end;

procedure TF_RangeEdit.FormCreate(Sender: TObject);
var n:byte;
begin
  SaveOnClose:=TRUE;
  DB:=open_rangeedit_data;
  DBD:=open_rangeedit_data;
  Multi:=open_rangeedit_multi;
  move(open_rangeedit_pat,pat,sizeof(pat));
  DBToScreen;
  n:=0;
  while L_RangeEdit[n].inst<>NIL do inc(n);
  L_RangeEdit[n].db:=DB;
  L_RangeEdit[n].inst:=self;
  L_RangeEdit[n].ready:=FALSE;
end;

end.
