unit U_Dialog_Scan;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls,
  U_Exchange, U_HexaDeci, U_ADF, U_Crc32;

var open_scan_filename:string;

type
  TF_Scan = class(TForm)
    P_Status: TPanel;
    GB_Results: TGroupBox;
    LV_Results: TListView;
    GB_Options: TGroupBox;
    B_Start: TButton;
    Label1: TLabel;
    Label2: TLabel;
    ED_Source: TEdit;
    ED_Target: TEdit;
    B_SourceSelect: TButton;
    B_TargetSelect: TButton;
    OD: TOpenDialog;
    Memo1: TMemo;
    procedure B_SourceSelectClick(Sender: TObject);
    procedure B_TargetSelectClick(Sender: TObject);
    procedure B_StartClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    procedure GetADFList(path:string; crop:longword);
    { Private declarations }
  public
    DB:DB_Base;
    Closable:Boolean;
    { Public declarations }
  end;

type TExecuteProc=procedure (S:TF_Scan);

type TCustomThread=class(TThread)
       procedure Execute; override;
     public
       ScanForm:TF_Scan;
       ExecuteProc:TExecuteProc;
     end;

var
  F_Scan: TF_Scan;

implementation

{$R *.dfm}

procedure TCustomThread.Execute;
begin
  FreeOnTerminate:=TRUE;
  ExecuteProc(Self.ScanForm);
  Terminate;
end;

function LoadFile(t:pADF; df:DBE_File; var p:pointer; var sz:longword; bx:pointer; FFS:Boolean):longword;
type fdatt=array[0..0] of byte;
var FHB:pFileHeaderBlock;
    FEB:pFileExtBlock;
    FDB:pFileDataBlock;
    febp:longword;
    febn:longword;
    fdbn:longword;
    fdat:^fdatt;
    fdatp:longword;
    fdats:longword;
    read:array[0..1759] of byte;
    err:longword;
    blocks:^fdatt;
    tc:tcustomthread;
begin
  if df.FHBN<t^.buffs div $200 then begin
    blocks:=bx;
   { file header block }
    FHB:=@t^.buffl^[$80*df.FHBN];
    FEB:=@FHB^;
    sz:=FHB^.Size; ADF_FlipLong(sz);
    if sz>t^.buffs then sz:=t^.buffs;
    getmem(fdat,sz); p:=fdat;
   { init }
    err:=0;
    fillchar(read,1760,$00);
    fillchar(blocks^,1760,$00);
    read[df.FHBN]:=1;
    febp:=$48;
    febn:=df.FHBN;
    fdatp:=$00;
   { load }
    while (fdatp<sz) and (err=0) do begin
     { load next file extension block }
      if (err=0) and (febp>=$48) then begin
        if (febn<t^.buffs div $200) then begin
          if blocks^[febn]=0 then begin
            blocks^[febn]:=1;
            FEB:=@t^.buffl^[$80*febn];
            if ADF_CalcChecksum(FEB^,$200,$14,1)=FEB^.ChkSum then begin
              read[febn]:=1;
              febn:=FEB^.Extension; ADF_FlipLong(febn);
              febp:=$00;
            end else err:=BT_FExt or BT_ChkSErr or (febn shl $10);
          end else err:=BT_FExt or BT_Recurse or (febn shl $10);
        end else err:=BT_FExt or BT_ReadErr or (febn shl $10);
      end;
     { load next data block }
      if (err=0) then begin
        fdbn:=FEB^.DataBlocks[$47-febp]; ADF_FlipLong(fdbn);
        if (fdbn<t^.buffs div $200) then begin
          if blocks^[fdbn]=0 then begin
            blocks^[fdbn]:=1;
            FDB:=@t^.buffl^[$80*fdbn];
            fdats:=sz-fdatp;
            if FFS then begin
              if fdats>$200 then fdats:=$200;
              read[fdbn]:=1;
              move(FDB^,fdat^[fdatp],fdats);
              inc(fdatp,fdats);
            end else begin
              if ADF_CalcChecksum(FDB^,$200,$14,1)=FDB^.ChkSum then begin
                if FDB^.PrimType=$08000000 then begin
                  if fdats>$1e8 then fdats:=$1e8;
                  read[fdbn]:=1;
                  move(FDB^.Data,fdat^[fdatp],fdats);
                  inc(fdatp,fdats);
                end else begin
                  err:=BT_Data or BT_BadType or (fdbn shl $01);
                end;
              end else begin
                err:=BT_Data or BT_ChkSErr or (fdbn shl $10);
              end;
            end;
            inc(febp);
          end else err:=BT_Data or BT_Recurse or (fdbn shl $10);
        end else err:=BT_Data or BT_ReadErr or (fdbn shl $10);
      end;
    end;
  end else begin
    err:=BT_FileH or BT_ReadErr or (df.FHBN shl $10);
    sz:=0;
    p:=NIL;
  end;
  LoadFile:=Err;
end;

var GFL_Used:array[$000..$6df] of byte;

procedure InitGetFileList;
begin
  FillChar(GFL_Used,$6e0,$00);
end;

procedure GetFileList(s:string; p:pADF; var f:DBE_File; bn:longword);
var pRoot:pRootBlock;
    pDir:pDirBlock;
    pFHdr:pFileheaderBlock;
    hp:longword;
    ab:longword;
    tf,nf:DBE_File;
begin
  if (GFL_Used[bn]=0) and (bn<p^.buffs div $200) then begin
    pDir:=@p^.buffl^[$80*bn];
    GFL_Used[bn]:=1;
    if ADF_CalcCheckSum(pDir^,$200,$14,1)=pDir^.ChkSum then begin
      for hp:=$00 to $47 do begin
        ab:=pDir^.HT[hp];
        ADF_Fliplong(ab);
        while (ab>0) and (ab<p^.buffs div $200) do begin
          if GFL_Used[ab]=0 then begin
            GFL_Used[ab]:=1;
            pFHdr:=@p^.buffl^[$80*ab];
            if ADF_GetBlockType(p,ab)=BT_Dir then begin
              GFL_Used[ab]:=0;
              GetFileList(s+pFhdr^.Name+'/',p,f,ab);
            end else
            if ADF_GetBlockType(p,ab)=BT_FileH then begin
              New(nf);
              nf^.FHBN:=ab;
              nf^.Name:=s+pFHdr^.Name;
              nf^.Size:=pFHdr^.Size;
              ADF_FlipLong(nf^.Size);
              nf^.Prev:=NIL;
              nf^.Next:=NIL;
              if f=NIL then f:=nf else begin
                tf:=f;
                while tf^.next<>NIL do tf:=tf^.next;
                tf^.next:=nf;
                nf^.prev:=tf;
              end;
            end;
            ab:=pFHdr^.NextHash;
            ADF_FlipLong(ab);
          end else ab:=0;
        end;
      end;
    end;
  end;
end;

procedure KillFileList(var DBEF:DBE_File);
var TTDBEF:DBE_File;
begin
  while DBEF<>NIL do begin
    TTDBEF:=DBEF;
    DBEF:=DBEF^.Next;
    Dispose(TTDBEF);
  end;
end;

procedure TF_Scan.B_SourceSelectClick(Sender: TObject);
var s:string;
    b:byte;
begin
  OD:=TOpenDialog.Create(self);
  OD.Title:='Select source directory ...';
  OD.FileName:='No file selection needed';
  if OD.Execute then begin
    s:=OD.FileName;
    b:=length(s);
    while s[b]<>'\' do dec(b);
    ED_Source.Text:=copy(s,1,b);
  end;
end;

procedure TF_Scan.B_TargetSelectClick(Sender: TObject);
var s:string;
    b:byte;
begin
  OD:=TOpenDialog.Create(self);
  OD.Title:='Select target directory ...';
  OD.FileName:='No file selection needed';
  if OD.Execute then begin
    s:=OD.FileName;
    b:=length(s);
    while s[b]<>'\' do dec(b);
    ED_Target.Text:=copy(s,1,b);
  end;
end;

var ListCount:longword;

procedure TF_Scan.GetADFList(path:string; crop:longword);
var sr:TSearchRec;
    ff:boolean;
    s:string;
    TI:TListItem;
begin
  ff:=FindFirst(path+'*.*',$3f,sr)=0;
  while ff do begin
    if (sr.Attr and $1c=$00) then begin
      s:=path+sr.name;
      if copy(upcasestr(s),length(s)-3,4)='.ADF' then begin
        TI:=LV_Results.Items.Add;
        TI.Caption:=copy(s,crop+1,length(s)-crop-4);
        inc(ListCount);
{        P_Status.Caption:=IntToStr(ListCount)+' files found';
        P_Status.Repaint;}
      end;
    end else if (sr.Name<>'.') and (sr.Name<>'..') and (sr.Attr and $10=$10) then begin
      GetADFList(path+sr.name+'\',crop);
    end;
    ff:=FindNext(sr)=0;
  end;
  FindClose(sr);
end;

procedure KillDiskResults(var SCR:SC_Result);
var TSCR:SC_Result;
begin
  while SCR<>NIL do begin
    TSCR:=SCR;
    SCR:=SCR^.next;
    Dispose(TSCR);
  end;
end;

procedure AddDiskResults(DBS:DB_Soft; DBD:DB_Disk; var SCR:SC_Result);
var TSCR:SC_Result;
    already:boolean;
begin
  already:=FALSE;
  if SCR=NIL then begin
    New(SCR);
    TSCR:=SCR;
  end else begin
    TSCR:=SCR;
    while (TSCR^.Next<>NIL) and (not already) do begin
      if (TSCR^.DBD=DBD) and (TSCR^.DBS=DBS) then begin
        already:=TRUE;
      end else TSCR:=TSCR^.Next;
    end;
    if (TSCR^.DBD=DBD) and (TSCR^.DBS=DBS) then already:=TRUE;
    if not already then begin
      New(TSCR^.Next);
      TSCR:=TSCR^.Next;
    end;
  end;
  if not already then begin
    TSCR^.next:=NIL;
    TSCR^.DBD:=DBD;
    TSCR^.DBS:=DBS;
    TSCR^.ACC:=0;
  end;
end;

procedure IdentifySector(ADF:pADF; sectx:longword; SC:SC_SCan; var SCR:SC_Result);
var DBR:DB_Range;
    scanx:longword;
    t:text;
begin
 { calc crc32 }
  New(DBR);
  DBR^.addr1:=sectx*$200;
  DBR^.addr2:=sectx*$200+$1ff;
  CRCStart(DBR^.crc32);
  CRCAddBuffer(DBR^.crc32,ADF^.buffb^[sectx*$200],$200);
  CRCEnd(DBR^.crc32);
 { find fitting disk(s) }
  scanx:=0;
  repeat
    if SCN_HigherR(DBR,SC.scr^[scanx].DBR) then begin
      scanx:=SC.scr^[scanx].SCR;
    end else begin
      if SCN_HigherR(SC.scr^[scanx].DBR,DBR) then begin
        scanx:=SC.scr^[scanx].SCL;
      end else begin
        repeat
          AddDiskResults(SC.scr^[scanx].DBS,SC.scr^[scanx].DBD,SCR);
          scanx:=SC.scr^[scanx].SCE;
        until scanx=0;
{        repeat
          if (SC.scr^[scanx].DBR^.addr1=DBR^.addr1) and (SC.scr^[scanx].DBR^.crc32=DBR^.crc32) then begin
            AddDiskResults(SC.scr^[scanx].DBS,SC.scr^[scanx].DBD,SCR);
            scanx:=SC.scr^[scanx].SCR;
            if (SCN_HigherR(SC.scr^[scanx].DBR,DBR)) then begin
              repeat
                while (SCN_HigherR(SC.scr^[scanx].DBR,DBR)) and (scanx<>0) do scanx:=SC.scr^[scanx].SCL;
                if (scanx<>0) and (SC.scr^[scanx].DBR^.addr1=DBR^.addr1) and (SC.scr^[scanx].DBR^.crc32=DBR^.crc32) then begin
                  AddDiskResults(SC.scr^[scanx].DBS,SC.scr^[scanx].DBD,SCR);
                  scanx:=SC.scr^[scanx].SCR;
                end;
              until scanx=0;
            end;
          end else scanx:=0;
        until scanx=0;}
      end;
    end;
  until scanx=0;

  Dispose(DBR);
end;

procedure IdentifyFile(ADF:pADF; FFS:Boolean; DBEF:DBE_File; SC:SC_Scan; var SCRR:SC_Result);
var DBF:DB_File;
    P:Pointer;
    PS:LongWord;
    Blocks:array[0..1759] of byte;
    ERR:LongWord;
    scanx:longword;
begin
 { load file, get last error and calculate CRC32 }
  ERR:=LoadFile(ADF,DBEF,P,PS,@Blocks,FFS);
  DBEF^.LastError:=ERR;
  if ERR=0 then begin
    CRCStart(DBEF^.crc32);
    CRCAddBuffer(DBEF^.crc32,P^,PS);
    CRCEnd(DBEF^.crc32);
  end else DBEF^.crc32:=ERR;
  FreeMem(P,PS);

 { find fitting disk(s) }
  New(DBF); DBF^.filename:=NIL; SetPSString(DBF^.filename,DBEF^.name); DBF^.size:=DBEF^.Size; DBF^.crc32:=DBEF^.CRC32;
  scanx:=0;
  repeat
    if SCN_HigherF(DBF,SC.scf^[scanx].DBF) then begin
      scanx:=SC.scf^[scanx].SCR;
    end else begin
      if SCN_HigherF(SC.scf^[scanx].DBF,DBF) then begin
        scanx:=SC.scf^[scanx].SCL;
      end else begin
        repeat
          AddDiskResults(SC.scf^[scanx].DBS,SC.scf^[scanx].DBD,SCRR);
          scanx:=SC.scf^[scanx].SCE;
        until scanx=0;
      end;
    end;
  until scanx=0;

  Dispose(DBF);
end;

function NameIdentified(DBF:DB_File; DBEF:DBE_File):boolean;
var s1,s2:string;
begin
  s1:=UpcaseStr(GetPSString(DBF^.filename));
  s2:=UpcaseStr(DBEF^.name);
  NameIdentified:=StringsMatch(s1,s2);
end;

function DataIdentified(DBF:DB_File; DBEF:DBE_File):boolean;
begin
  DataIdentified:=(DBF^.crc32=DBEF^.CRC32) and (DBF^.size=DBEF^.Size);
end;

function GetAccuracy(ADF:pADF; DBEF:DBE_File; SCR:SC_Result):longword;
var TDBF:DB_File;
    TDBR:DB_Range;
    TDBEF:DBE_File;
    crcv:longword;
    found,fileid:boolean;
    misses,identified,files:longword;
    rb:pRootBlock;
begin
  misses:=0;
  identified:=0;
  files:=0;

  fillchar(SCR^.DS,sizeof(SCR^.DS),0);

 { Disk name }
  if SCR^.DBD^.DiskName<>NIL then begin
    rb:=@ADF^.buffb^[$200*880];
    if UpcaseStr(rb^.Name)<>UpcaseStr(GetPSSTring(SCR^.DBD^.DiskName)) then begin
      if SCR^.DBD^.NameMatch=0 then SCR^.DS.nd:=TRUE else SCR^.DS.nb:=TRUE;
    end;
  end;

 { check ranges }
  TDBR:=SCR^.DBD^.ranges;
  while TDBR<>NIL do begin
    inc(files);
    if ADF^.buffs>TDBR^.addr2 then begin
      CRCStart(crcv);
      CRCAddBuffer(crcv,ADF^.buffb^[TDBR^.addr1],TDBR^.addr2-TDBR^.addr1+1);
      CRCEnd(crcv);
      if crcv<>TDBR^.crc32 then begin
        if TDBR^.info and DBI_HIGHSCORES<>0 then begin
          SCR^.DS.hdx:=crcv;
          inc(identified);
        end else begin
          if TDBR^.info and DBI_PREGAME<>0    then inc(SCR^.DS.pdx) else
          if TDBR^.info and DBI_GAME<>0       then inc(SCR^.DS.mdx) else
          if TDBR^.info and DBI_ADDENDUM<>0   then inc(SCR^.DS.adx) else
          if TDBR^.info and DBI_UNUSED<>0     then inc(SCR^.DS.udx);
        end;
      end else inc(identified);
    end else begin
      if (TDBR^.info and DBI_OPTIONAL<>0) then begin
        if TDBR^.info and DBI_PREGAME<>0    then inc(SCR^.DS.pmx) else
        if TDBR^.info and DBI_GAME<>0       then inc(SCR^.DS.mmx) else
        if TDBR^.info and DBI_ADDENDUM<>0   then inc(SCR^.DS.amx) else
        if TDBR^.info and DBI_UNUSED<>0     then inc(SCR^.DS.umx);
      end;
      inc(misses);
    end;
    TDBR:=TDBR^.next;
  end;

 { check files }
  TDBEF:=DBEF;
  while TDBEF<>NIL do begin
    inc(SCR^.DS.xx);
    TDBEF:=TDBEF^.Next;
  end;
  TDBF:=SCR^.DBD^.Files;
  while TDBF<>NIL do begin
    inc(files);
    TDBEF:=DBEF; fileid:=FALSE; found:=FALSE;
    while (TDBEF<>NIL) and (not fileid) do begin
      if DataIdentified(TDBF,TDBEF) or NameIdentified(TDBF,TDBEF) then begin
        fileid:=TRUE;
        found:=TRUE;
        dec(SCR^.DS.xx);
        if not NameIdentified(TDBF,TDBEF) then begin
          if TDBF^.info and DBI_PREGAME<>0    then inc(SCR^.DS.pnx) else
          if TDBF^.info and DBI_GAME<>0       then inc(SCR^.DS.mnx) else
          if TDBF^.info and DBI_ADDENDUM<>0   then inc(SCR^.DS.anx) else
          if TDBF^.info and DBI_UNUSED<>0     then inc(SCR^.DS.unx);
        end else if not DataIdentified(TDBF,TDBEF) then begin
          if TDBEF^.LastError<>0 then begin
            if TDBF^.info and DBI_PREGAME<>0    then inc(SCR^.DS.pbx) else
            if TDBF^.info and DBI_GAME<>0       then inc(SCR^.DS.mbx) else
            if TDBF^.info and DBI_ADDENDUM<>0   then inc(SCR^.DS.abx) else
            if TDBF^.info and DBI_UNUSED<>0     then inc(SCR^.DS.ubx);
          end else begin
            if UpcaseStr(GetPSString(TDBF^.filename))='/S/STARTUP-SEQUENCE' then begin
              SCR^.DS.sd:=TRUE;
              SCR^.DS.sdx:=TDBEF^.CRC32;
            end else
            if TDBF^.info and DBI_HIGHSCORES<>0 then begin
              SCR^.DS.hdx:=TDBEF^.CRC32;
              SCR^.DS.hd:=TRUE;
            end else
            if TDBF^.info and DBI_SAVEGAME<>0 then begin
              inc(SCR^.DS.sgx);
              SCR^.DS.sgy:=SCR^.DS.sgy xor TDBEF^.CRC32;
              fileid:=FALSE;
              TDBEF:=TDBEF^.Next;
            end else
            if TDBF^.info and DBI_PREGAME<>0    then inc(SCR^.DS.pdx) else
            if TDBF^.info and DBI_GAME<>0       then inc(SCR^.DS.mdx) else
            if TDBF^.info and DBI_ADDENDUM<>0   then inc(SCR^.DS.adx) else
            if TDBF^.info and DBI_UNUSED<>0     then inc(SCR^.DS.udx);
          end;
        end;
      end else TDBEF:=TDBEF^.Next;
    end;

    if not found then begin
      if (TDBF^.info and DBI_OPTIONAL=0) then begin
        if TDBF^.info and DBI_RELEASETRO<>0 then SCR^.DS.ru:=TRUE else
        if TDBF^.info and DBI_CRACKTRO<>0   then SCR^.DS.cu:=TRUE else
        if TDBF^.info and DBI_TRAINER<>0    then SCR^.DS.tu:=TRUE else
        if TDBF^.info and DBI_HDINSTALL<>0  then SCR^.DS.hu:=TRUE else
        if TDBF^.info and DBI_DOCS<>0       then SCR^.DS.du:=TRUE else
        if TDBF^.info and DBI_PREGAME<>0    then inc(SCR^.DS.pmx) else
        if TDBF^.info and DBI_GAME<>0       then inc(SCR^.DS.mmx) else
        if TDBF^.info and DBI_ADDENDUM<>0   then inc(SCR^.DS.amx) else
        if TDBF^.info and DBI_UNUSED<>0     then inc(SCR^.DS.umx);
      end;
      inc(misses);
    end else begin
      inc(identified);
    end;
    TDBF:=TDBF^.next;
  end;
  GetAccuracy:=Trunc(identified/files*1000);
end;

function GetErrorTags(ADF:pADF; DBEF:DBE_File; SCR:SC_Result):string;
var TDBF:DB_File;
    TDBEF:DBE_File;
    filefound:boolean;
    files,filesfound,filesbad:longword;
    s:string;
begin
  s:='';
  if SCR^.DS.pmx>0 then s:=s+'[pm'+IntToStr(SCR^.DS.pmx)+']';
  if SCR^.DS.pbx>0 then s:=s+'[pb'+IntToStr(SCR^.DS.pbx)+']';
  if SCR^.DS.pnx>0 then s:=s+'[pn'+IntToStr(SCR^.DS.pnx)+']';
  if SCR^.DS.pdx>0 then s:=s+'[pd'+IntToStr(SCR^.DS.pdx)+']';
  if SCR^.DS.mmx>0 then s:=s+'[mm'+IntToStr(SCR^.DS.mmx)+']';
  if SCR^.DS.mbx>0 then s:=s+'[mb'+IntToStr(SCR^.DS.mbx)+']';
  if SCR^.DS.mnx>0 then s:=s+'[mn'+IntToStr(SCR^.DS.mnx)+']';
  if SCR^.DS.mdx>0 then s:=s+'[md'+IntToStr(SCR^.DS.mdx)+']';
  if SCR^.DS.amx>0 then s:=s+'[am'+IntToStr(SCR^.DS.amx)+']';
  if SCR^.DS.abx>0 then s:=s+'[ab'+IntToStr(SCR^.DS.abx)+']';
  if SCR^.DS.anx>0 then s:=s+'[an'+IntToStr(SCR^.DS.anx)+']';
  if SCR^.DS.adx>0 then s:=s+'[ad'+IntToStr(SCR^.DS.adx)+']';
  if SCR^.DS.umx>0 then s:=s+'[am'+IntToStr(SCR^.DS.umx)+']';
  if SCR^.DS.ubx>0 then s:=s+'[ab'+IntToStr(SCR^.DS.ubx)+']';
  if SCR^.DS.unx>0 then s:=s+'[an'+IntToStr(SCR^.DS.unx)+']';
  if SCR^.DS.udx>0 then s:=s+'[ad'+IntToStr(SCR^.DS.udx)+']';
  if SCR^.DS.cu then s:=s+'[cu]';
  if SCR^.DS.tu then s:=s+'[tu]';
  if SCR^.DS.ru then s:=s+'[ru]';
  if SCR^.DS.hu then s:=s+'[hu]';
  if SCR^.DS.du then s:=s+'[du]';
  if SCR^.DS.hd then s:=s+'[hd'+Hexa(SCR^.DS.hdx,4)+']';
  if SCR^.DS.sd then s:=s+'[sd'+Hexa(SCR^.DS.sdx,4)+']';
  if SCR^.DS.sgx>0 then s:=s+'[sg'+IntToStr(SCR^.DS.sgx)+'|'+hexa(SCR^.DS.sgx,4)+']';
  if SCR^.DS.xx>0 then s:=s+'[x'+IntToStr(SCR^.DS.xx)+']';

(*  SCR^.DS.ha:=FALSE; SCR^.DS.hcrc32:=0; SCR^.DS.dna:=FALSE; SCR^.DS.dnb:=FALSE;
  SCR^.DS.fbc:=0; SCR^.DS.fbg:=0; SCR^.DS.fbm:=0; SCR^.DS.fbs:=0;
  SCR^.DS.fmc:=0; SCR^.DS.fmg:=0; SCR^.DS.fmm:=0; SCR^.DS.fms:=0;
  SCR^.DS.fwc:=0; SCR^.DS.fwg:=0; SCR^.DS.fwm:=0; SCR^.DS.fws:=0;
  SCR^.DS.rmc:=0; SCR^.DS.rmg:=0; SCR^.DS.rmm:=0; SCR^.DS.rms:=0;
  SCR^.DS.rwc:=0; SCR^.DS.rwg:=0; SCR^.DS.rwm:=0; SCR^.DS.rws:=0;
  SCR^.DS.sa:=FALSE; SCR^.DS.scrc32:=0; SCR^.DS.sg:=0; SCR^.DS.uf:=0;*)
(*  s:='';
  if SCR^.DS.fb>0  then s:=s+'[fb '+IntToStr(SCR^.DS.fb)+']';
  if SCR^.DS.fbc>0 then s:=s+'[fbc '+IntToStr(SCR^.DS.fbc)+']';
  if SCR^.DS.fbg>0 then s:=s+'[fbg '+IntToStr(SCR^.DS.fbg)+']';
  if SCR^.DS.fbs>0 then s:=s+'[fbs '+IntToStr(SCR^.DS.fbs)+']';
  if SCR^.DS.fw>0  then s:=s+'[fw '+IntToStr(SCR^.DS.fw)+']';
  if SCR^.DS.fwc>0 then s:=s+'[fwc '+IntToStr(SCR^.DS.fwc)+']';
  if SCR^.DS.fwg>0 then s:=s+'[fwg '+IntToStr(SCR^.DS.fwg)+']';
  if SCR^.DS.fws>0 then s:=s+'[fws '+IntToStr(SCR^.DS.fws)+']';
  if SCR^.DS.fm>0  then s:=s+'[fm '+IntToStr(SCR^.DS.fm)+']';
  if SCR^.DS.fmc>0 then s:=s+'[fmc '+IntToStr(SCR^.DS.fmc)+']';
  if SCR^.DS.fmg>0 then s:=s+'[fmg '+IntToStr(SCR^.DS.fmg)+']';
  if SCR^.DS.fms>0 then s:=s+'[fms '+IntToStr(SCR^.DS.fms)+']';
  if SCR^.DS.rm>0  then s:=s+'[rm '+IntToStr(SCR^.DS.rm)+']';
  if SCR^.DS.rmc>0 then s:=s+'[rmc '+IntToStr(SCR^.DS.rmc)+']';
  if SCR^.DS.rmg>0 then s:=s+'[rmg '+IntToStr(SCR^.DS.rmg)+']';
  if SCR^.DS.rms>0 then s:=s+'[rms '+IntToStr(SCR^.DS.rms)+']';
  if SCR^.DS.rw>0  then s:=s+'[rw '+IntToStr(SCR^.DS.rw)+']';
  if SCR^.DS.rwc>0 then s:=s+'[rwc '+IntToStr(SCR^.DS.rwc)+']';
  if SCR^.DS.rwg>0 then s:=s+'[rwg '+IntToStr(SCR^.DS.rwg)+']';
  if SCR^.DS.rws>0 then s:=s+'[rws '+IntToStr(SCR^.DS.rws)+']';*)
  GetErrorTags:=s;
end;

procedure TF_Scan_B_StartClick(s:TF_Scan);
var itemx:longword;
    SC:SC_Scan;
    ADF:pADF;
    sourcedir:string;
    TDBEF,DBEF:DBE_File;
    FFS:Boolean;
    Boot:pBootBlock;
    TSCR,SCR:SC_Result;
    str:string;
    RESU:array[$00..$ff] of record
           DBS:DB_Soft;
           DBD:DB_Disk;
           ACC:longword;
           SCR:SC_Result;
         end;
    RESUN:longword;
    l0,l1,l2,l3:longword;
begin
  s.Closable:=FALSE;
  s.B_Start.Enabled:=FALSE;
  s.P_Status.Caption:='Preparing ADF list ...';
  ListCount:=0;
  s.LV_Results.Clear;
  s.LV_Results.Hide;
  sourcedir:=s.ED_Source.Text;
  s.GetADFList(sourcedir,length(sourcedir));
  s.LV_Results.AlphaSort;
  s.LV_Results.Show;
  SCN_InitDB(s.DB,SC);
  for itemx:=0 to ListCount-1 do begin
    l1:=trunc(((itemx+1)/listcount)*100);
    s.P_Status.Caption:='Scanning file '+IntToStr(itemx+1)+' of '+IntToStr(ListCount)+' ['+IntToStr(l1)+'] / '+sourcedir+s.LV_Results.Items.Item[itemx].Caption;
    ADF:=ADF_Open(sourcedir+s.LV_Results.Items.Item[itemx].Caption+'.adf',OM_ReadOnly);
    InitGetFileList; DBEF:=NIL; Boot:=@ADF^.buffb^[0];
    FFS:=Boot^.DiskType and ($01000000)=$01000000;
    DBEF:=NIL; GetFileList('/',ADF,DBEF,880);
   { identify files and get possible disks list }
    SCR:=NIL; TDBEF:=DBEF;
    while TDBEF<>NIL do begin
      IdentifyFile(ADF,FFS,TDBEF,SC,SCR);
      TDBEF:=TDBEF^.Next;
    end;
   { identify sectors and get possible disks list }
    for l0:=0 to ADF^.buffs div $200-1 do begin
      IdentifySector(ADF,l0,SC,SCR);
    end;
   { get disk accuracies }
    TSCR:=SCR;
    if SCR<>NIL then beep;
    while TSCR<>NIL do begin
      TSCR^.ACC:=GetAccuracy(ADF,DBEF,TSCR);
      TSCR:=TSCR^.Next;
    end;
   { get disk names }
    RESUN:=0;
    fillchar(RESU,sizeof(RESU),0);
    TSCR:=SCR;
    while TSCR<>NIL do begin
      if TSCR^.ACC>=500 then begin
        l0:=0;
        while (l0<RESUN) and (RESU[l0].DBS<>TSCR^.DBS) do inc(l0);
        if l0=RESUN then begin
          RESU[l0].DBS:=TSCR^.DBS;
          RESU[l0].DBD:=TSCR^.DBD;
          RESU[l0].ACC:=TSCR^.ACC;
          RESU[l0].SCR:=TSCR;
          inc(RESUN);
        end else begin
          if RESU[l0].ACC<TSCR^.ACC then begin
            RESU[l0].DBS:=TSCR^.DBS;
            RESU[l0].DBD:=TSCR^.DBD;
            RESU[l0].ACC:=TSCR^.ACC;
            RESU[l0].SCR:=TSCR;
          end;
        end;
      end;
      TSCR:=TSCR^.next;
    end;
    if RESUN>0 then begin
      str:='';
      for l0:=0 to RESUN-1 do begin
        if str<>'' then str:=str+' + ';
        str:=str+GetDiskName(RESU[l0].DBS,RESU[l0].DBD)+GetErrorTags(ADF,DBEF,RESU[l0].SCR)+' ('+inttostr(RESU[l0].SCR^.ACC)+')';
      end;
    end else str:='<unidentified>';

(*    TSCR:=SCR;
    str:='';
    while TSCR<>NIL do begin
      if TSCR.ACC>=50 then begin
        if str<>'' then str:=str+' / ';     { Test0001 }
        str:=str+GetDiskName({ADF,DBEF,TSCR}TSCR^.DBS, TSCR^.DBD)+' ('+IntToStr(TSCR.ACC div 10)+')';
      end;
      TSCR:=TSCR^.Next;
    end;*)

    s.LV_Results.Items.Item[itemx].SubItems.Clear;
    s.LV_Results.Items.Item[itemx].SubItems.Add(str);
    KillDiskResults(SCR);
    KillFileList(DBEF);
    ADF_Close(ADF);
  end;
  SCN_DeInit(SC);
  s.B_Start.Enabled:=TRUE;
  S.Closable:=TRUE;
  s.P_Status.Caption:='Ready.';
end;

procedure TF_Scan.B_StartClick(Sender: TObject);
var tc:TCustomThread;
begin
  tc:=TCustomThread.Create(TRUE);
  tc.ExecuteProc:=TF_Scan_B_StartClick;
  tc.ScanForm:=self;
  tc.Resume;
end;

procedure TF_Scan.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DEL_Base(DB);
  Release;
end;

procedure TF_Scan.FormCreate(Sender: TObject);
begin
  DIDLoad(DB,open_scan_filename);
  Closable:=TRUE;
end;

procedure TF_Scan.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=CLOSABLE;
end;

end.
