unit U_Dialog_VersionEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, U_Exchange, U_HexaDeci;

var open_versionedit_data:DB_Version;

type
  TF_VersionEdit = class(TForm)
    VE_StandardInfo: TGroupBox;
    ST_Name: TStaticText;
    ED_Name: TEdit;
    ED_Publisher: TEdit;
    ED_RelDay: TEdit;
    ED_RelMonth: TEdit;
    ED_RelYear: TEdit;
    ST_Publisher: TStaticText;
    ST_RD: TStaticText;
    VE_Credits: TGroupBox;
    ED_Developer: TEdit;
    ST_Developer: TStaticText;
    ST_Code: TStaticText;
    ED_Code: TEdit;
    ST_Graphics: TStaticText;
    ED_Graphics: TEdit;
    ST_SoundFX: TStaticText;
    ED_SoundFX: TEdit;
    ST_Music: TStaticText;
    ED_Music: TEdit;
    ST_Design: TStaticText;
    ED_Design: TEdit;
    VE_Comment: TGroupBox;
    M_Comment: TMemo;
    B_Save: TButton;
    B_Okay: TButton;
    B_Cancel: TButton;
    VE_Hint1: TPanel;
    L_ArrowRight: TLabel;
    L_ArrowLeft: TLabel;
    VE_Details: TGroupBox;
    ST_Chipset: TStaticText;
    RB_OCS: TRadioButton;
    RB_ECS: TRadioButton;
    RB_AGA: TRadioButton;
    ST_Mem: TStaticText;
    ED_MemC: TEdit;
    ED_MemS: TEdit;
    ED_MemF: TEdit;
    ST_KB: TStaticText;
    ST_VersionName: TStaticText;
    ED_VersionName: TEdit;
    ST_Protection: TStaticText;
    ED_Protection: TEdit;
    ST_Cracked: TStaticText;
    ED_Cracked: TEdit;
    ST_Fix: TStaticText;
    ST_Fixed: TStaticText;
    ED_Fixed: TEdit;
    CB_AGAFix: TCheckBox;
    CB_HDFix: TCheckBox;
    CB_680x0Fix: TCheckBox;
    ST_Modification: TStaticText;
    ED_Modification: TEdit;
    ED_Modified: TEdit;
    ST_Modified: TStaticText;
    ST_Parent: TStaticText;
    ED_Parent: TEdit;
    B_TakeParent: TPanel;
    ST_DiskOrder: TStaticText;
    VE_Compat: TGroupBox;
    CB_68000: TCheckBox;
    Label1: TLabel;
    CB_68010: TCheckBox;
    CB_680EC20: TCheckBox;
    CB_68020: TCheckBox;
    CB_FPU: TCheckBox;
    CB_68040: TCheckBox;
    Label2: TLabel;
    CB_CycleExact: TCheckBox;
    CB_ImmediateBlitter: TCheckBox;
    CB_FastCopper: TCheckBox;
    Label3: TLabel;
    CB_MoreCompatible: TCheckBox;
    CB_FastestSpeed: TCheckBox;
    CB_SpeedAdjust: TCheckBox;
    ED_SpeedAdjust: TEdit;
    Label4: TLabel;
    CB_FloppyTurbo: TCheckBox;
    CB_Floppy2x: TCheckBox;
    CB_Floppy4x: TCheckBox;
    CB_Floppy8x: TCheckBox;
    Label5: TLabel;
    CB_KS12: TCheckBox;
    CB_KS13: TCheckBox;
    CB_KS21: TCheckBox;
    CB_KS30: TCheckBox;
    CB_KS31: TCheckBox;
    CB_KS35: TCheckBox;
    Label6: TLabel;
    CB_OCS: TCheckBox;
    CB_ECS: TCheckBox;
    CB_AGA: TCheckBox;
    ED_FDDNum: TEdit;
    Label7: TLabel;
    CB_FDDNum: TCheckBox;
    Label8: TLabel;
    CB_SpecialMem: TCheckBox;
    StaticText1: TStaticText;
    ED_SpecialChip: TEdit;
    ED_SpecialSlow: TEdit;
    ED_SpecialFast: TEdit;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    Label9: TLabel;
    CB_WinUAE: TCheckBox;
    CB_WinFellow: TCheckBox;
    ED_WinUAEv1: TEdit;
    ED_WinUAEv2: TEdit;
    ED_WinUAEv3: TEdit;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    ED_WinUAEv4: TEdit;
    ED_WinFellowv1: TEdit;
    ED_WinFellowv2: TEdit;
    ED_WinFellowv3: TEdit;
    ST_Trainer: TStaticText;
    ST_Trained: TStaticText;
    ED_TrainerOpts: TEdit;
    ED_Trained: TEdit;
    ED_TrainerKeys: TEdit;
    ST_TrainerOpts: TStaticText;
    ST_TrainerKeys: TStaticText;
    StaticText7: TStaticText;
    CB_En: TCheckBox;
    CB_De: TCheckBox;
    CB_Pl: TCheckBox;
    CB_Dk: TCheckBox;
    CB_Se: TCheckBox;
    CB_No: TCheckBox;
    CB_Nl: TCheckBox;
    CB_Be: TCheckBox;
    CB_OtherLang: TCheckBox;
    ED_DiskOrder: TEdit;
    ST_Released: TStaticText;
    ED_Released: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure B_CancelClick(Sender: TObject);
    procedure B_OkayClick(Sender: TObject);
    procedure B_SaveClick(Sender: TObject);
  private
    procedure DBToScreen;
    procedure ScreenToDB;
    { Private declarations }
  public
    { Public declarations }
    DB:DB_Version;
    SaveOnClose:Boolean;
  end;

var
  F_VersionEdit: TF_VersionEdit;

implementation

{$R *.dfm}

procedure SetCheckBox(cb:TCheckBox; val:longword);
begin
  if val=$02 then cb.State:=cbGrayed else
  if val=$01 then cb.State:=cbChecked else cb.State:=cbUnChecked;
end;

function GetCheckBox(cb:TCheckBox):longword;
var val:longword;
begin
  if cb.State=cbChecked then val:=$01 else
  if cb.State=cbGrayed then val:=$02 else val:=$00;
  GetCheckBox:=val;
end;

procedure TF_VersionEdit.DBToScreen;
var s:string;
    n:byte;
begin
  M_Comment.Clear;
  if DB^.comment<>NIL then M_Comment.Lines.Add(GetPSString(DB^.comment));

 { Standard Info }

  if DB^.publisher<>NIL then ED_Publisher.Text:=DB.publisher^;
  if DB^.gamename<>NIL then ED_Name.Text:=DB.gamename^;
  if DB^.developer<>NIL then ED_Developer.Text:=DB.developer^;
  if DB^.programm<>NIL then ED_Code.Text:=DB.programm^;
  if DB^.graphics<>NIL then ED_Graphics.Text:=DB.graphics^;
  if DB^.soundfx<>NIL then ED_SoundFX.Text:=DB.soundfx^;
  if DB^.music<>NIL then ED_Music.Text:=DB.music^;
  if DB^.design<>NIL then ED_Design.Text:=DB.design^;
  ED_RelYear.Text:=IntToStr(DB.releaseyear);
  ED_RelMonth.Text:=IntToStr(DB.releasemonth);
  ED_RelDay.Text:=IntToStr(DB.releaseday);

 { Compatibility }

  SetCheckBox(CB_68000,  (DB.compat.cpu shr $00) and $03);
  SetCheckBox(CB_68010,  (DB.compat.cpu shr $02) and $03);
  SetCheckBox(CB_68020,  (DB.compat.cpu shr $04) and $03);
  SetCheckBox(CB_680ec20,(DB.compat.cpu shr $06) and $03);
  SetCheckBox(CB_68040,  (DB.compat.cpu shr $08) and $03);
  SetCheckBox(CB_FPU,    (DB.compat.cpu shr $0a) and $03);

  SetCheckBox(CB_CycleExact,      (DB.compat.chipset shr $00) and $03);
  SetCheckBox(CB_ImmediateBlitter,(DB.compat.chipset shr $02) and $03);
  SetCheckBox(CB_FastCopper,      (DB.compat.chipset shr $04) and $03);

  SetCheckBox(CB_Floppy2x,   (DB.compat.floppy shr $00) and $03);
  SetCheckBox(CB_Floppy4x,   (DB.compat.floppy shr $02) and $03);
  SetCheckBox(CB_Floppy8x,   (DB.compat.floppy shr $04) and $03);
  SetCheckBox(CB_FloppyTurbo,(DB.compat.floppy shr $06) and $03);
  SetCheckBox(CB_FDDNum,     (DB.compat.floppy shr $08) and $03);
  ED_FDDNum.Text:=IntToStr(DB.compat.floppy shr $0c);

  SetCheckBox(CB_OCS,(DB.compat.graphics shr $00) and $03);
  SetCheckBox(CB_ECS,(DB.compat.graphics shr $02) and $03);
  SetCheckBox(CB_AGA,(DB.compat.graphics shr $04) and $03);

  SetCheckBox(CB_SpecialMem,(DB.compat.memory shr $00) and $03);
  ED_SpecialChip.Text:=IntToStr(DB.compat.memchip);
  ED_SpecialSlow.Text:=IntToStr(DB.compat.memslow);
  ED_SpecialFast.Text:=IntToStr(DB.compat.memfast);

  SetCheckBox(CB_KS12,(DB.compat.kickstart shr $00) and $03);
  SetCheckBox(CB_KS13,(DB.compat.kickstart shr $02) and $03);
  SetCheckBox(CB_KS21,(DB.compat.kickstart shr $04) and $03);
  SetCheckBox(CB_KS30,(DB.compat.kickstart shr $06) and $03);
  SetCheckBox(CB_KS31,(DB.compat.kickstart shr $08) and $03);
  SetCheckBox(CB_KS35,(DB.compat.kickstart shr $0a) and $03);

  SetCheckBox(CB_MoreCompatible,(DB.compat.special shr $00) and $03);
  SetCheckBox(CB_FastestSpeed,  (DB.compat.special shr $02) and $03);
  SetCheckBox(CB_SpeedAdjust,   (DB.compat.special shr $04) and $03);
  ED_SpeedAdjust.Text:=IntToStr(DB.compat.special shr $0c);

  ED_WinUAEv1.Text:=IntToStr((DB.compat.winuae shr $08) and $0f);
  ED_WinUAEv2.Text:=IntToStr((DB.compat.winuae shr $0c) and $ff);
  ED_WinUAEv3.Text:=IntToStr((DB.compat.winuae shr $14) and $ff);
  ED_WinUAEv4.Text:=IntToStr((DB.compat.winuae shr $1c) and $0f);
  SetCheckBox(CB_WinUAE,(DB.compat.winuae shr $00) and $03);

  ED_WinFellowv3.Text:=IntToStr((DB.compat.winfellow shr $08) and $ff);
  ED_WinFellowv2.Text:=IntToStr((DB.compat.winfellow shr $10) and $ff);
  ED_WinFellowv1.Text:=IntToStr((DB.compat.winfellow shr $18) and $ff+1980);
  SetCheckBox(CB_WinFellow,(DB.compat.winfellow shr $00) and $03);

 { Details }

  ED_MemC.Text:=IntToStr(DB^.memc);
  ED_MemS.Text:=IntToStr(DB^.mems);
  ED_MemF.Text:=IntToStr(DB^.memf);
  ED_Parent.Text:=IntToStr(DB^.parent);
  ED_VersionName.Text:=GetPSString(DB^.versionname);
  ED_Protection.Text:=GetPSString(DB^.protection);
  ED_Cracked.Text:=GetPSString(DB^.cracker);
  ED_Released.Text:=GetPSString(DB^.releaser);
  ED_Fixed.Text:=GetPSString(DB^.fixer);
  ED_Modification.Text:=GetPSString(DB^.modification);
  ED_Modified.Text:=GetPSString(DB^.modificator);
  ED_Trained.Text:=GetPSString(DB^.trainer);

  if DB^.graphicschip=$02 then RB_AGA.Checked:=TRUE else
  if DB^.graphicschip=$01 then RB_ECS.Checked:=TRUE else RB_OCS.Checked:=TRUE;

  CB_AGAFix.Checked  :=DB^.fix and $01=$01;
  CB_HDFix.Checked   :=DB^.fix and $02=$02;
  CB_680x0Fix.Checked:=DB^.fix and $04=$04;

  ED_TrainerOpts.Text:=IntToStr((DB^.train shr $00) and $ff);
  ED_TrainerKeys.Text:=IntToStr((DB^.train shr $08) and $ff);

  CB_En.Checked       :=DB^.lang and $00000001=$00000001;
  CB_De.Checked       :=DB^.lang and $00000002=$00000002;
  CB_Pl.Checked       :=DB^.lang and $00000004=$00000004;
  CB_Dk.Checked       :=DB^.lang and $00000008=$00000008;
  CB_Se.Checked       :=DB^.lang and $00000010=$00000010;
  CB_No.Checked       :=DB^.lang and $00000020=$00000020;
  CB_Nl.Checked       :=DB^.lang and $00000040=$00000040;
  CB_Be.Checked       :=DB^.lang and $00000080=$00000080;
  CB_OtherLang.Checked:=DB^.lang and $80000000=$80000000;

  s:='';
  for n:=$00 to $ff do if DB^.disks[n]<>$00 then s:=s+IntToStr(DB^.disks[n])+', ';
  ED_DIskOrder.Text:=copy(s,1,length(s)-2);
end;

procedure TF_VersionEdit.ScreenToDB;
var s:string;
    n,o,p:byte;
begin
  SetPSString(DB^.comment,MemoToString(M_Comment));

 { Standard Info }

  SetPSString(DB^.publisher,ED_Publisher.Text);
  SetPSString(DB^.gamename,ED_Name.Text);
  SetPSString(DB^.developer,ED_Developer.Text);
  SetPSString(DB^.programm,ED_Code.Text);
  SetPSString(DB^.graphics,ED_Graphics.Text);
  SetPSString(DB^.soundfx,ED_SoundFX.Text);
  SetPSString(DB^.music,ED_Music.Text);
  SetPSString(DB^.design,ED_Design.Text);
  DB^.releaseyear:=StrToInt(ED_RelYear.Text);
  DB^.releasemonth:=StrToInt(ED_RelMonth.Text);
  DB^.releaseday:=StrToInt(ED_RelDay.Text);

 { Compatibility }

  DB.compat.cpu:=GetCheckBox(CB_68000)   shl $00
                +GetCheckBox(CB_68010)   shl $02
                +GetCheckBox(CB_68020)   shl $04
                +GetCheckBox(CB_680ec20) shl $06
                +GetCheckBox(CB_68040)   shl $08
                +GetCheckBox(CB_FPU)     shl $0a;

  DB.compat.chipset:=GetCheckBox(CB_CycleExact)       shl $00
                    +GetCheckBox(CB_ImmediateBlitter) shl $02
                    +GetCheckBox(CB_FastCopper)       shl $04;

  DB.compat.floppy:=GetCheckBox(CB_Floppy2x)    shl $00
                   +GetCheckBox(CB_Floppy4x)    shl $02
                   +GetCheckBox(CB_Floppy8x)    shl $04
                   +GetCheckBox(CB_FloppyTurbo) shl $06
                   +GetCheckBox(CB_FDDNum)      shl $08
                   +StrToInt(ED_FDDNum.Text)    shl $0c;

  DB.compat.graphics:=GetCheckBox(CB_OCS) shl $00
                     +GetCheckBox(CB_ECS) shl $02
                     +GetCheckBox(CB_AGA) shl $04;

  DB.compat.memory:=GetCheckBox(CB_SpecialMem) shl $00;
  DB.compat.memchip:=StrToInt(ED_SpecialChip.Text);
  DB.compat.memslow:=StrToInt(ED_SpecialSlow.Text);
  DB.compat.memfast:=StrToInt(ED_SpecialFast.Text);

  DB.compat.kickstart:=GetCheckBox(CB_KS12) shl $00
                      +GetCheckBox(CB_KS13) shl $02
                      +GetCheckBox(CB_KS21) shl $04
                      +GetCheckBox(CB_KS30) shl $06
                      +GetCheckBox(CB_KS31) shl $08
                      +GetCheckBox(CB_KS35) shl $0a;

  DB.compat.special:=GetCheckBox(CB_MoreCompatible) shl $00
                    +GetCheckBox(CB_FastestSpeed)   shl $02
                    +GetCheckBox(CB_SpeedAdjust)    shl $04
                    +StrToInt(ED_SpeedAdjust.Text)  shl $0c;

  DB.compat.winuae:=GetCheckBox(CB_WinUAE)     shl $00
                   +StrToInt(ED_WinUAEv1.Text) shl $08
                   +StrToInt(ED_WinUAEv2.Text) shl $0c
                   +StrToInt(ED_WinUAEv3.Text) shl $14
                   +StrToInt(ED_WinUAEv4.Text) shl $1c;

  DB.compat.winfellow:=GetCheckBox(CB_WinFellow)     shl $00
                      +StrToInt(ED_WinFellowv3.Text) shl $08
                      +StrToInt(ED_WinFellowv2.Text) shl $10
                      +(StrToInt(ED_WinFellowv1.Text)-1980) shl $18;

 { Details }

  DB^.memc:=StrToInt(ED_MemC.Text);
  DB^.mems:=StrToInt(ED_MemS.Text);
  DB^.memf:=StrToInt(ED_MemF.Text);
  DB^.parent:=StrToInt(ED_Parent.Text);
  SetPSString(DB^.versionname,ED_VersionName.Text);
  SetPSString(DB^.protection,ED_Protection.Text);
  SetPSString(DB^.cracker,ED_Cracked.Text);
  SetPSString(DB^.releaser,ED_Released.Text);
  SetPSString(DB^.fixer,ED_Fixed.Text);
  SetPSString(DB^.modification,ED_Modification.Text);
  SetPSString(DB^.modificator,ED_Modified.Text);
  SetPSString(DB^.trainer,ED_Trained.Text);
  if RB_AGA.Checked then DB^.graphicschip:=$02 else
  if RB_ECS.Checked then DB^.graphicschip:=$01 else DB^.graphicschip:=$00;

  DB^.fix:=0;
  if CB_AGAFix.Checked then inc(DB^.fix,$01);
  if CB_HDFix.Checked then inc(DB^.fix,$02);
  if CB_680x0Fix.Checked then inc(DB^.fix,$04);

  DB^.train:=StrToInt(ED_TrainerOpts.Text)+StrToInt(ED_TrainerKeys.Text) shl $08;

  DB^.lang:=$00000000;
  if CB_En.Checked        then inc(DB^.lang,$00000001);
  if CB_De.Checked        then inc(DB^.lang,$00000002);
  if CB_Pl.Checked        then inc(DB^.lang,$00000004);
  if CB_Dk.Checked        then inc(DB^.lang,$00000008);
  if CB_Se.Checked        then inc(DB^.lang,$00000010);
  if CB_No.Checked        then inc(DB^.lang,$00000020);
  if CB_Nl.Checked        then inc(DB^.lang,$00000040);
  if CB_Be.Checked        then inc(DB^.lang,$00000080);
  if CB_OtherLang.Checked then inc(DB^.lang,$80000000);

  fillchar(DB^.disks,$100,$00);
  n:=1;
  p:=0;
  s:=ED_DiskOrder.Text;
  while n<=length(s) do begin
    if (s[n]>=#$30) and (s[n]<=#$39) then begin
      o:=0;
      while (s[n+o]>=#$30) and (s[n+o]<=#$39) and (n+o<=length(s)) do inc(o);
      DB^.disks[p]:=StrToInt(copy(s,n,o));
      inc(p);
      inc(n,o);
    end else inc(n);
  end;
end;

procedure TF_VersionEdit.FormCreate(Sender: TObject);
var n:byte;
begin
  SaveOnClose:=FALSE;
  DB:=open_versionedit_data;
  DBToScreen;
  n:=0;
  while L_VersionEdit[n].inst<>NIL do inc(n);
  L_VersionEdit[n].db:=DB;
  L_VersionEdit[n].inst:=self;
  L_VersionEdit[n].ready:=FALSE;
end;

procedure TF_VersionEdit.FormClose(Sender: TObject;
  var Action: TCloseAction);
var n:byte;
begin
  if SaveOnClose then ScreenToDB;
  n:=0;
  while L_VersionEdit[n].inst<>self do inc(n);
  L_VersionEdit[n].ready:=TRUE;
  Release;
end;

procedure TF_VersionEdit.B_CancelClick(Sender: TObject);
begin
  SaveOnClose:=FALSE;
  Self.Close;
end;

procedure TF_VersionEdit.B_OkayClick(Sender: TObject);
begin
  SaveOnClose:=TRUE;
  Self.Close;
end;

procedure TF_VersionEdit.B_SaveClick(Sender: TObject);
begin
  ScreenToDB;
  DBToScreen;
end;

end.
