unit U_HexEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, U_HexaDeci;

var he_bufp:pointer;
    he_bufl:longword;
    he_rdyp:pointer;

type the_ba=array[0..0] of byte;
     the_bufp=^the_ba;
     the_rdyp=^boolean;

type
  TF_HexEdit = class(TForm)
    Bevel1: TBevel;
    Memo1: TMemo;
    RichEdit1: TRichEdit;
    Memo2: TMemo;
    ScrollBar1: TScrollBar;
    Panel1: TPanel;
    procedure RichEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure RichEdit1SelectionChange(Sender: TObject);
    procedure UpdateRich(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ScrollBar1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    bufp:the_bufp;
    bufpos:longword;
    bufl:longword;
    rdyp:the_rdyp;
  end;

var
  F_HexEdit: TF_HexEdit;

implementation

{$R *.dfm}

procedure TF_HexEdit.RichEdit1KeyPress(Sender: TObject; var Key: Char);
var l,sel,lin,pos:longint;
    s:string;
begin
  l:=Self.RichEdit1.SelStart; sel:=l;
  l:=l-l div $31; lin:=l div $30;
  pos:=l mod $30; {pos:=pos-pos div $03;}

  s:=Self.RichEdit1.Lines.Strings[Lin];
  s[pos+1]:=key;
  Self.RichEdit1.Lines.Strings[Lin]:=s;

  Self.RichEdit1.SelStart:=sel+1;
  if pos mod $03=$01 then Self.RichEdit1.SelStart:=sel+2;
  RichEdit1SelectionChange(Self);
end;

var oldsel:longint;

procedure TF_HexEdit.UpdateRich(Sender: TObject);
var l,m:longword;
    s:string;
begin
  RichEdit1.clear;
  Memo2.clear;
  bufpos:=ScrollBar1.Position*$10;
  for l:=0 to 15 do begin
    s:='';
    for m:=0 to 15 do begin
      if bufpos+l*$10+m<bufl then s:=s+hexa(bufp^[bufpos+l*$10+m],2)
                             else s:=s+'..';
      if m<15 then s:=s+' ';
    end;
    RichEdit1.Lines.Add(s);
    s:='';
    for m:=0 to 15 do begin
      if bufpos+l*$10+m<bufl then begin
        if bufp^[bufpos+l*$10+m]>$1f then s:=s+char(bufp^[bufpos+l*$10+m]) else s:=s+'.';
      end else s:=s+' ';
    end;
    Memo2.Lines.Add(s);
  end;
  Memo1.Clear;
  for l:=0 to 15 do begin
    m:=bufpos+l*$10;
    Memo1.Lines.Add(Hexa(m,8));
  end;
  Memo1.SelStart:=0;
end;

procedure TF_HexEdit.RichEdit1SelectionChange(Sender: TObject);
var l1,l2,l:longword;
    back:TNotifyEvent;
begin
  l1:=Self.RichEdit1.SelStart; l2:=l1;
  l1:=l1-l1 div $31;
  if l1=$300 then begin
    back:=Self.RichEdit1.OnSelectionChange;
    Self.RichEdit1.OnSelectionChange:=NIL;
    UpdateRich(self);
    Self.RichEdit1.OnSelectionChange:=back;
    Self.RichEdit1.SelStart:=oldsel mod $31;
  end else begin
    if (l1 mod 3=2) then begin
      if oldsel<=Self.RichEdit1.SelStart then Self.RichEdit1.SelStart:=Self.RichEdit1.SelStart+1
                                         else Self.RichEdit1.SelStart:=Self.RichEdit1.SelStart-1;
    end;
    if (l1 mod $30=$2f) then begin
      if oldsel<Self.RichEdit1.SelStart then Self.RichEdit1.SelStart:=Self.RichEdit1.SelStart+2
                                        else Self.RichEdit1.SelStart:=Self.RichEdit1.SelStart;
    end;
    oldsel:=Self.RichEdit1.SelStart;
  end;
end;

procedure TF_HexEdit.FormCreate(Sender: TObject);
var back:tnotifyevent;
begin
  self.bufp:=he_bufp;
  self.rdyp:=he_rdyp;
  self.rdyp^:=TRUE;
  self.bufl:=he_bufl;
  self.bufpos:=0;
  back:=Self.RichEdit1.OnSelectionChange;
  Self.RichEdit1.OnSelectionChange:=NIL;
  UpdateRich(self);
  Self.RichEdit1.OnSelectionChange:=back;
  Self.RichEdit1.SelStart:=0;
  ScrollBar1.Min:=0;
  if (bufl div $10)>$0f then ScrollBar1.Max:=bufl div $10-$0f else ScrollBar1.Max:=1;
end;

procedure TF_HexEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  self.rdyp^:=FALSE;
end;

procedure TF_HexEdit.ScrollBar1Change(Sender: TObject);
var back:tnotifyevent;
begin
  back:=Self.RichEdit1.OnSelectionChange;
  Self.RichEdit1.OnSelectionChange:=NIL;
  UpdateRich(self);
  Self.RichEdit1.OnSelectionChange:=back;
  Self.RichEdit1.SelStart:=0;
end;

end.
