unit U_Inspector;

interface

uses
  Windows, Classes, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, SysUtils,
  U_ADF, U_Exchange, U_HexaDeci, U_CRC32, U_HExEdit, GR32_Image, Graphics,
  ImgList, Menus, U_Dialog_DiskEdit;

const CL_Unused :longword=$000000; {medium gray}
      CL_Root   :longword=$ffff00; {soft blue}
      CL_Dir    :longword=$c0b000; {light blue}
      CL_FileH  :longword=$48e048; {light green}
      CL_HLink  :longword=$ff40ff;
      CL_SLink  :longword=$c000c0;
      CL_FExt   :longword=$30a030;
      CL_Data   :longword=$206020; {ultrasoft green}
      CL_DirC   :longword=$4040ff;
      CL_Boot1  :longword=$000000;
      CL_Boot2  :longword=$000000;
      CL_Unform :longword=$c02020;

var TDI_Inspector_open:record
      Filename:string;
    end;

type
  TDI_Inspector = class(TForm)
    DI_Properties: TGroupBox;
    DI_Files: TGroupBox;
    ST_Name: TStaticText;
    ST_Boot: TStaticText;
    ED_Boot: TEdit;
    ED_Name: TEdit;
    Bootable: TCheckBox;
    DOS: TCheckBox;
    FFS: TCheckBox;
    DirC: TCheckBox;
    Intl: TCheckBox;
    SectorMap: TGroupBox;
    SI_Bevel: TBevel;
    SI_Header: TStaticText;
    SI_Memo: TMemo;
    FR_FileList: TListView;
    FR_Bevel: TBevel;
    FR_Header: TStaticText;
    FR_Memo: TMemo;
    ImgField: TLabel;
    Img: TPaintBox32;
    ST_Track: TLabel;
    ST_Sect: TLabel;
    ST_Block: TLabel;
    ST_Head: TLabel;
    SMP_Track: TLabel;
    SMP_Head: TLabel;
    SMP_Sect: TLabel;
    SMP_Block: TLabel;
    FR_HexEd: TImage;
    FR_AddDat: TImage;
    FR_Delete: TImage;
    Panel1: TPanel;
    SI_Define: TImage;
    SI_DefineImgs: TImageList;
    SMP_BlockDec: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    FR_Imgs: TImageList;
    Label3: TLabel;
    LG_Unused: TLabel;
    LG_Root: TLabel;
    LG_Dir: TLabel;
    LG_FileH: TLabel;
    LG_HLink: TLabel;
    LG_SLink: TLabel;
    LG_Fext: TLabel;
    LG_Data: TLabel;
    LG_DirC: TLabel;
    LG_Boot: TLabel;
    LG_Unform: TLabel;
    PU_AddDat: TPopupMenu;
    Disk11: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure DrawStats(S:TDI_Inspector);
    procedure BootableClick(Sender: TObject);
    procedure ImgMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FR_FileListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SI_DefineClick(Sender: TObject);
    procedure SI_DefineClick2(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure PopupClick(Sender:TOBject);
    procedure FormActivate(Sender: TObject);
    procedure FR_DeleteClick(Sender: TObject);
    procedure FR_HexEdClick(Sender: TObject);
    procedure SI_DefineMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FR_AddDatClick(Sender: TObject);
  private
    { Private declarations }
  public
    L_Hex:array[$00..$ff] of record
      bufp:pointer;
      bufl:longword;
      notready:boolean;
    end;
    ADFName:string;
    ADF:pADF;
    Stats:record
            DOS:boolean;
            FFS:boolean;
            DIRC:boolean;
            INTL:boolean;
            Bootblock:string[$ff];
            Diskname:string[$ff];
            Blocks:array[0..1759] of longword;
            Bootable:boolean;
          end;
    Files:DBE_File;
    Ranges:DBE_Range;
    RBeg:longword;
    REnd:longword;
    SectX,SectY:Integer;
    Closing:boolean;
    { Public declarations }
  end;

implementation

{$R *.dfm}

procedure DrawSectorMark(t:TDI_Inspector; sn:longword; cl:longword);
var xw,yw,xp,yp:longword;
begin
  xw:=t.Img.Buffer.Width;
  yw:=t.Img.Buffer.Height;
  for xp:=(sn mod 40) to (sn mod 40+1) do begin
    for yp:=(sn div 40)*(yw-1) div 44 to (sn div 40+1)*(yw-1) div 44 do t.Img.Buffer.Pixel[xp*(xw-1) div 40,yp]:=cl;
  end;
  for yp:=(sn div 40) to (sn div 40+1) do begin
    for xp:=(sn mod 40)*(xw-1) div 40 to (sn mod 40+1)*(xw-1) div 40 do t.Img.Buffer.Pixel[xp,yp*(yw-1) div 44]:=cl;
  end;
end;

procedure DrawSectorGrid(t:TDI_Inspector);
var xw,yw,x,y:longword;
begin
 { create canvas }
  xw:=t.Img.Buffer.Width;
  yw:=t.Img.Buffer.Height;
  for x:=0 to 40 do begin
    for y:=0 to yw-1 do t.img.Buffer.Pixel[x*(xw-1) div 40,y]:=$404040;
  end;
  for y:=0 to 44 do begin
    for x:=0 to xw-1 do t.img.Buffer.Pixel[x,y*(yw-1) div 44]:=$404040;
  end;
  for x:=0 to 1759 do if t.stats.blocks[x] and BT_Selected=BT_Selected then DrawSectorMark(t,x,$ff4000);
  for x:=0 to 1759 do if t.stats.blocks[x] and BT_Inspect=BT_Inspect then DrawSectorMark(t,x,$ffffff);
  t.Img.Repaint;
end;

procedure DrawSectorMap(t:TDI_Inspector);
var xw,yw,x,y,x1,x2,y1,y2,bt,cl,l0:longword;
begin
  xw:=t.Img.Buffer.Width;
  yw:=t.Img.Buffer.Height;
  for l0:=0 to 1759 do begin
    bt:=t.stats.blocks[l0];
    if bt=BT_Unused then cl:=CL_Unused else
    if bt=BT_Root then   cl:=CL_Root else
    if bt=BT_Dir then    cl:=CL_Dir else
    if bt=BT_FileH then  cl:=CL_FileH else
    if bt=BT_HLink then  cl:=CL_HLink else
    if bt=BT_SLink then  cl:=CL_SLink else
    if bt=BT_FExt then   cl:=CL_FExt else
    if bt=BT_Data then   cl:=CL_Data else
    if bt=BT_DirC then   cl:=CL_DirC else
    if bt=BT_UNform then cl:=CL_Unform else
    if bt=BT_Boot1 then  cl:=CL_Boot1 else
    if bt=BT_Boot2 then  cl:=CL_Boot2;
    x:=l0 mod 40;
    y:=l0 div 40;
    x1:=((x)*(xw-1) div 40);
    x2:=((x+1)*(xw-1) div 40);
    y1:=((y)*(yw-1) div 44);
    y2:=((y+1)*(yw-1) div 44);
    for x:=x1+1 to x2-1 do for y:=y1+1 to y2-1 do t.Img.Buffer.Pixel[x,y]:=cl;
    bt:=t.stats.blocks[l0];
    if (bt and BT_ChksErr)<>0 then begin
      t.Img.Buffer.Pixel[x1+1,y1+1]:=$ff2020;
      t.Img.Buffer.Pixel[x1+2,y1+1]:=$ff2020;
      t.Img.Buffer.Pixel[x1+3,y1+1]:=$ff2020;
      t.Img.Buffer.Pixel[x1+1,y1+2]:=$ff2020;
      t.Img.Buffer.Pixel[x1+2,y1+2]:=$ff2020;
      t.Img.Buffer.Pixel[x1+1,y1+3]:=$ff2020;
{      for x:=x1+1 to x2-1 do t.Img.Buffer.Pixel[x,y1+(y2-y1)*(x-x1) div (x2-x1)]:=$ff0000;
      for x:=x1+1 to x2-1 do t.Img.Buffer.Pixel[x,y1+(y2-y1)*(x2-x) div (x2-x1)]:=$ff0000;}
{      t.Img.Canvas.MoveTo(x1+1,y1+1);
      t.Img.Canvas.LineTo(x2,y2);
      t.Img.Canvas.MoveTo(x1+1,y2-1);
      t.Img.Canvas.LineTo(x2,y1);}
    end;
  end;
  t.Img.Repaint;
end;

procedure GetBlockStats(t:TDI_Inspector);
var l0,bt:longword;
begin
  for l0:=0 to 1759 do begin
    if l0<t.ADF^.buffs div $200 then t.Stats.Blocks[l0]:=ADF_GetBlockType(t.ADF,l0)
                                else t.Stats.Blocks[l0]:=BT_Unform;
  end;
end;

procedure TDI_Inspector.DrawStats(S:TDI_Inspector);
begin
  S.ED_Name.Text:=S.Stats.DiskName;
  S.DOS.Checked:=S.Stats.DOS;
  S.Bootable.Checked:=S.Stats.Bootable;
  S.FFS.Checked:=S.Stats.FFS;
  S.INTL.Checked:=S.Stats.INTL;
  S.DirC.Checked:=S.Stats.Dirc;
end;

procedure DrawFileList(f:DBE_File; r:DBE_Range; lv:TListView);
begin
  lv.Clear;
  while f<>NIL do begin
    lv.AddItem(f.Name,NIL);
    if f.lasterror<>0 then lv.Items.Item[lv.Items.Count-1].ImageIndex:=1
                      else lv.Items.Item[lv.Items.Count-1].ImageIndex:=0;
    lv.Items.Item[lv.Items.Count-1].SubItems.Add(IntToStr(f.Size));
    lv.Items.Item[lv.Items.Count-1].Data:=f;
    lv.Items.Item[lv.Items.Count-1].SubItems.Add(Hexa(f.CRC32,$08));
    f:=f.next;
  end;
  while r<>NIL do begin
    lv.AddItem(r.Name,NIL);
    lv.Items.Item[lv.Items.Count-1].ImageIndex:=0;
    lv.Items.Item[lv.Items.Count-1].SubItems.Add(IntToStr(r.Size));
    lv.Items.Item[lv.Items.Count-1].Data:=r;
    lv.Items.Item[lv.Items.Count-1].SubItems.Add(Hexa(r.CRC32,$08));
    r:=r.next;
  end;
  lv.AlphaSort;
end;

function LoadFile(t:TDI_Inspector; df:DBE_File; var p:pointer; var sz:longword; bx:pointer):longword;
type fdatt=array[0..0] of byte;
var FHB:pFileHeaderBlock;
    FEB:pFileExtBlock;
    FDB:pFileDataBlock;
    febp:longword;
    febn:longword;
    fdbn:longword;
    fdat:^fdatt;
    fdatp:longword;
    fdats:longword;
    read:array[0..1759] of byte;
    err:longword;
    blocks:^fdatt;
begin
  if df.FHBN<t.ADF^.buffs div $200 then begin
    blocks:=bx;
   { file header block }
    FHB:=@t.ADF^.buffl^[$80*df.FHBN];
    FEB:=@FHB^;
    sz:=FHB^.Size; ADF_FlipLong(sz);
    if sz>t.ADF^.buffs then sz:=t.ADF^.buffs;
    getmem(fdat,sz); p:=fdat;
   { init }
    err:=0;
    fillchar(read,1760,$00);
    fillchar(blocks^,1760,$00);
    read[df.FHBN]:=1;
    febp:=$48;
    febn:=df.FHBN;
    fdatp:=$00;
   { load }
    while (fdatp<sz) and (err=0) do begin
     { load next file extension block }
      if (err=0) and (febp>=$48) then begin
        if (febn<t.ADF^.buffs div $200) then begin
          if blocks^[febn]=0 then begin
            blocks^[febn]:=1;
            FEB:=@t.ADF^.buffl^[$80*febn];
            if ADF_CalcChecksum(FEB^,$200,$14,1)=FEB^.ChkSum then begin
              read[febn]:=1;
              febn:=FEB^.Extension; ADF_FlipLong(febn);
              febp:=$00;
            end else err:=BT_FExt or BT_ChkSErr or (febn shl $10);
          end else err:=BT_FExt or BT_Recurse or (febn shl $10);
        end else err:=BT_FExt or BT_ReadErr or (febn shl $10);
      end;
     { load next data block }
      if (err=0) then begin
        fdbn:=FEB^.DataBlocks[$47-febp]; ADF_FlipLong(fdbn);
        if (fdbn<t.ADF^.buffs div $200) then begin
          if blocks^[fdbn]=0 then begin
            blocks^[fdbn]:=1;
            FDB:=@t.ADF^.buffl^[$80*fdbn];
            fdats:=sz-fdatp;
            if t.stats.FFS then begin
              if fdats>$200 then fdats:=$200;
              read[fdbn]:=1;
              move(FDB^,fdat^[fdatp],fdats);
              inc(fdatp,fdats);
            end else begin
              if ADF_CalcChecksum(FDB^,$200,$14,1)=FDB^.ChkSum then begin
                if FDB^.PrimType=$08000000 then begin
                  if fdats>$1e8 then fdats:=$1e8;
                  read[fdbn]:=1;
                  move(FDB^.Data,fdat^[fdatp],fdats);
                  inc(fdatp,fdats);
                end else begin
                  err:=BT_Data or BT_BadType or (fdbn shl $01);
                end;
              end else begin
                err:=BT_Data or BT_ChkSErr or (fdbn shl $10);
              end;
            end;
            inc(febp);
          end else err:=BT_Data or BT_Recurse or (fdbn shl $10);
        end else err:=BT_Data or BT_ReadErr or (fdbn shl $10);
      end;
    end;
  end else begin
    err:=BT_FileH or BT_ReadErr or (df.FHBN shl $10);
    sz:=0;
    p:=NIL;
  end;
  LoadFile:=Err;
end;

var GFL_Used:array[$000..$6df] of byte;

procedure InitGetFileList;
begin
  FillChar(GFL_Used,$6e0,$00);
end;

procedure GetFileList(s:string; p:pADF; var f:DBE_File; bn:longword);
var pRoot:pRootBlock;
    pDir:pDirBlock;
    pFHdr:pFileheaderBlock;
    hp:longword;
    ab:longword;
    tf,nf:DBE_File;
begin
  if (GFL_Used[bn]=0) and (bn<p^.buffs div $200) then begin
    pDir:=@p^.buffl^[$80*bn];
    GFL_Used[bn]:=1;
    if ADF_CalcCheckSum(pDir^,$200,$14,1)=pDir^.ChkSum then begin
      for hp:=$00 to $47 do begin
        ab:=pDir^.HT[hp];
        ADF_Fliplong(ab);
        while (ab>0) and (ab<p^.buffs div $200) do begin
          if GFL_Used[ab]=0 then begin
            GFL_Used[ab]:=1;
            pFHdr:=@p^.buffl^[$80*ab];
            if ADF_GetBlockType(p,ab)=BT_Dir then begin
              GFL_Used[ab]:=0;
              GetFileList(s+pFhdr^.Name+'/',p,f,ab);
            end else
            if ADF_GetBlockType(p,ab)=BT_FileH then begin
              New(nf);
              nf^.FHBN:=ab;
              nf^.Name:=s+pFHdr^.Name;
              nf^.Size:=pFHdr^.Size;
              ADF_FlipLong(nf^.Size);
              nf^.Prev:=NIL;
              nf^.Next:=NIL;
              if f=NIL then f:=nf else begin
                tf:=f;
                while tf^.next<>NIL do tf:=tf^.next;
                tf^.next:=nf;
                nf^.prev:=tf;
              end;
            end;
            ab:=pFHdr^.NextHash;
            ADF_FlipLong(ab);
          end else ab:=0;
        end;
      end;
    end;
  end;
end;

procedure GetUsedBlocks(t:TDI_Inspector);
begin
end;

function SwapRGB(l:longword):longword;
begin
  SwapRGB:=l and $ff00ff00+l and $ff shl $10+l and $ff0000 shr $10;
end;

procedure TDI_Inspector.FormCreate(Sender: TObject);
var Boot:pBootBlock;
    Root:pRootBlock;
    BitM:pBitMapBlock;
    BExt:pBitMapExtBlock;
    FHdr:pFileHeaderBlock;
    FExt:pFileExtBlock;
    FDat:pFileDataBlock;
    Dir:pDirBlock;
    HLnk:pHardLinkBlock;
    SLnk:pSoftLinkBlock;
    L:longword;
    af:DBE_File;
    lf:pointer;
    lfs:longword;
    lfe:longword;
    blocks:array[0..1759] of byte;
    b:byte;
begin
 { legend }
  LG_Unused.Color:=SwapRGB(CL_Unused);
  LG_Root.Color:=SwapRGB(CL_Root);
  LG_Dir.Color:=SwapRGB(CL_Dir);
  LG_FileH.Color:=SwapRGB(CL_FileH);
  LG_HLink.Color:=SwapRGB(CL_HLink);
  LG_SLink.Color:=SwapRGB(CL_SLink);
  LG_FExt.Color:=SwapRGB(CL_Fext);
  LG_Data.Color:=SwapRGB(CL_Data);
  LG_Dirc.Color:=SwapRGB(CL_Dirc);
  LG_Boot.Color:=SwapRGB(CL_Boot1);
  LG_Unform.Color:=SwapRGB(CL_Unform);
 { hexed }
  fillchar(L_Hex,sizeof(L_Hex),$00);

  Closing:=FALSE;
  Panel1.Caption:=TDI_Inspector_Open.FileName;
  ADFName:=TDI_Inspector_Open.FileName;
 { open ADF }
  ADF:=ADF_Open(ADFName,OM_ReadOnly);

 { scan rootblock => diskname }
  if 880<ADF^.buffs div $200 then begin
    Root:=@ADF^.buffl^[$80*880];
    if ADF_GetBlockType(ADF,880)=BT_Root then self.Stats.Diskname:=Root^.Name
                                         else self.Stats.Diskname:='NDOS:';
  end else self.Stats.Diskname:='NDOS:';
  for b:=1 to length(self.stats.diskname) do begin
    if (self.stats.diskname[b]<#$20) then self.stats.diskname[b]:='_';
  end;
 { scan bootblock => filesystem }
  if 1<ADF^.buffs div $200 then begin
    Boot:=@ADF^.buffl^[$80*0];
    self.Stats.FFS:=(Boot.DiskType and $01000000)=$01000000;
    self.Stats.INTL:=(Boot.DiskType and $06000000)<>$00000000;
    self.Stats.DIRC:=(Boot.DiskType and $04000000)=$04000000;
    self.Stats.DOS:=(Boot.DiskType and $00534f44)=$534f44;
    self.Stats.Bootable:=(Boot.Chksum=ADF_CalcChecksum(Boot^,$400,$04,$00));
  end;
 { get filelist }
  GetBlockStats(self);
  InitGetFileList;
  GetFileList('/',ADF,self.files,880);
  ranges:=NIL;
 { calculate crc32s }
  af:=self.files;
  while af<>NIL do begin
    lfe:=LoadFile(self,af,lf,lfs,@blocks);
    af.LastError:=lfe;
    if lfe=0 then begin
      CRCStart(af.crc32);
      CRCAddBuffer(af.crc32,lf^,lfs);
      CRCEnd(af.crc32);
    end else begin
      af.crc32:=lfe;
    end;
    freemem(lf,lfs);
    af:=af.Next;
  end;
  DrawFileList(self.files,self.ranges,self.FR_FileList);
  DrawStats(self);
end;

procedure TDI_Inspector.FormDestroy(Sender: TObject);
var lst:longint;
begin
end;

procedure TDI_Inspector.FormResize(Sender: TObject);
begin
  DrawSectorGrid(self);
  DrawSectorMap(self);
end;

procedure TDI_Inspector.BootableClick(Sender: TObject);
begin
  DrawStats(self);
end;

procedure TDI_Inspector.ImgMouseMove(Sender: TObject; Shift: TShiftState;  X, Y: Integer);
var sn:longword;
    l:longint;
begin
  SectX:=X; SectY:=Y;
  sn:=(SectX)*40 div img.width + ((SectY)*44 div img.height)*40;
  l:=(sn div 22); SMP_Track.Caption:=IntToStr(l);
  l:=(sn div 11) and 1; SMP_Head.Caption:=IntToStr(l);
  l:=(sn mod 11)+1; SMP_Sect.Caption:=IntToStr(l);
  SMP_Block.Caption:='$'+Hexa(sn,3);
  SMP_BlockDec.Caption:=IntToStr(sn);
end;

procedure TDI_Inspector.ImgMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var sn:longword;
    BootBlock:pBootBlock;
    RootBlock:pRootBlock;
    BitMapBlock:pBitMapBlock;
    BitMapExtBlock:pBitMapExtBlock;
    FileHeaderBlock:pFileHeaderBlock;
    FileExtBlock:pFileExtBlock;
    FileDataBlock:pFileDataBlock;
    DirBlock:pDirBlock;
    HardLinkBlock:pHardLinkBlock;
    SoftLinkBlock:pSoftLinkBlock;
    bt:longword;
    cs:longword;
    s:string;
    xw,yw,xp,yp:longword;
begin
  sn:=(SectX)*40 div img.width + ((SectY)*44 div img.height)*40;

 { create canvas }
  for xp:=0 to 1759 do stats.Blocks[xp]:=stats.Blocks[xp] and ($ffffffff xor BT_Inspect);
  stats.Blocks[sn]:=stats.Blocks[sn] or (BT_Inspect);
  DrawSectorGrid(self);
{  DrawSectorMark(self,sn,$ffffff);}

  BootBlock:=@ADF^.buffl^;
  RootBlock:=@ADF^.buffl^[$80*sn];
  BitMapBlock:=@ADF^.buffl^[$80*sn];
  BitMapExtBlock:=@ADF^.buffl^[$80*sn];
  FileHeaderBlock:=@ADF^.buffl^[$80*sn];
  FileExtBlock:=@ADF^.buffl^[$80*sn];
  FileDataBlock:=@ADF^.buffl^[$80*sn];
  DirBlock:=@ADF^.buffl^[$80*sn];
  HardLinkBlock:=@ADF^.buffl^[$80*sn];
  SoftLinkBlock:=@ADF^.buffl^[$80*sn];
  SI_Header.Caption:='Sector Info ($'+hexa(sn,3)+'):';
  SI_Memo.Lines.Clear;
  bt:=ADF_GetBlockType(ADF,sn) and $0f;
 { Bootblock }
  if (sn<2) then begin
    BootBlock:=@ADF^.buffl^;
    cs:=ADF_CalcCheckSum(BootBlock^,$400,$04,0);
    SI_Memo.Lines.Add('Block type ... Bootblock');
    SI_Memo.Lines.Add('Checksum (S/C) '+hexa(BootBlock.chksum,8)+'/'+hexa(cs,8));
  end else if bt=BT_Unused then begin
    SI_Memo.Lines.Add('Block type ... Unknown');
  end else begin
    s:='Block type ... ';
    if bt=BT_Root  then s:=s+'Rootblock' else
    if bt=BT_Dir   then s:=s+'Directory' else
    if bt=BT_FileH then s:=s+'File header' else
    if bt=BT_HLink then s:=s+'Hard link' else
    if bt=BT_SLink then s:=s+'Soft link' else
    if bt=BT_FExt  then s:=s+'File extension' else
    if bt=BT_Data  then s:=s+'File data' else
    if bt=BT_DirC  then s:=s+'Directory cache';
    SI_Memo.Lines.Add(s);
    cs:=ADF_CalcCheckSum(RootBlock^,$200,$14,1);
    SI_Memo.Lines.Add('Checksum (S/C) '+hexa(RootBlock.chksum,8)+'/'+hexa(cs,8));
  end;
  if bt=BT_Data then begin
    cs:=FileDataBlock^.HeaderKey;
    ADF_FlipLong(cs);
    SI_Memo.Lines.Add('File Header at $'+hexa(cs,3));
    FileHeaderBlock:=@ADF^.buffl^[$80*cs];
{    SI_Memo.Lines.Add('File Name .... '+FileHeaderBlock^.Name);}
  end;

  for xw:=$00 to $1f do begin
    s:=hexa(xw,3);
    for yw:=$00 to $0f do s:=s+' '+hexa(ADF^.buffb^[$200*sn+xw*$10+yw],2);
{    SI_Memo.Lines.Add(s);}
  end;
{  SI_Memo.Lines.Add('Scheisse!');}
end;

procedure TDI_Inspector.FR_FileListSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
var f:DBE_File;
    blocks:array[0..1759] of byte;
    p:pointer;
    sz:longword;
    l:longword;
begin
  if not closing then begin
    if Item.Caption[1]='/' then begin
      f:=Item.Data;
      if f<>NIL then begin
        LoadFile(self,f,p,sz,@blocks);
        Freemem(p,sz);
        for l:=0 to 1759 do if blocks[l]=1 then Stats.Blocks[l]:=Stats.Blocks[l] or BT_Selected
                                           else Stats.Blocks[l]:=Stats.Blocks[l] and (BT_Selected xor $ffffffff);
        DrawSectorGrid(self);
      end;
    end;
  end;
end;

procedure TDI_Inspector.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var b:byte;
begin
 { Lookup Hex-Editor }
  b:=0;
  while (L_Hex[b].notready=FALSE) and (b<$ff) do inc(b);
  if not L_Hex[b].notready then begin
    CanClose:=TRUE;
    Closing:=TRUE;
  end else CanClose:=FALSE;
end;

procedure TDI_Inspector.SI_DefineClick(Sender: TObject);
var x:longword;
begin
  SI_DefineImgs.GetIcon(1,SI_Define.Picture.Icon);
  SI_Define.OnClick:=SI_DefineClick2;
  for x:=0 to 1759 do if stats.blocks[x] and BT_Inspect=BT_Inspect then RBeg:=X*$200;
end;

procedure TDI_Inspector.SI_DefineClick2(Sender: TObject);
var tr,r:DBE_Range;
    x:longword;
begin
  new(r);
  SI_DefineImgs.GetIcon(0,SI_Define.Picture.Icon);
  SI_Define.OnClick:=SI_DefineClick;
  for x:=0 to 1759 do if stats.blocks[x] and BT_Inspect=BT_Inspect then REnd:=X*$200+$1ff;
  r^.Name:='@'+hexa(RBeg,8)+'-'+hexa(REnd,8);
  r^.Desc:='';
  r^.RBeg:=RBeg;
  r^.REnd:=REnd;
  r^.Size:=REnd-RBeg+1;
  CRCStart(r^.CRC32);
  CRCAddBuffer(r^.CRC32,ADF^.buffb^[R^.RBeg],R^.Size);
  CRCEnd(r^.CRC32);
  r^.Attr:=0;
  r^.Pack:=0;
  r^.Next:=NIL;
  r^.Prev:=NIL;
  if ranges=NIL then ranges:=r else begin
    tr:=ranges;
    while tr^.next<>NIL do tr:=tr^.next;
    tr^.next:=r;
    r^.prev:=tr;
  end;
  DrawFileList(files,ranges,FR_FileList);
end;

procedure TDI_Inspector.FormClose(Sender: TObject;
  var Action: TCloseAction);
var lst:longint;
begin
  lst:=0; while L_Inspector[lst]<>self do inc(lst);
  L_Inspector[lst]:=NIL;
  ADF_Close(ADF);
  Release;
end;


procedure TDI_Inspector.Button1Click(Sender: TObject);
var f:DBE_File;
    r:DBE_Range;
    blocks:array[0..1759] of byte;
    p:pointer;
    sz:longword;
    l:longword;
    he:TF_HexEdit;
    b:boolean;
    hp:byte;
begin
  if not closing then begin
    if FR_FileList.Selected.Caption[1]='/' then begin
      f:=FR_FileList.Selected.Data;
      if f<>NIL then begin
        LoadFile(self,f,p,sz,@blocks);
        hp:=0;
        while L_Hex[hp].notready do inc(hp);
        he_rdyp:=@L_Hex[hp].notready;
        he_bufl:=sz;
        he_bufp:=p;
        L_Hex[hp].bufp:=p;
        L_Hex[hp].bufl:=sz;
        he:=TF_HexEdit.Create(self);
        he.Panel1.Caption:=ADF.fn+' ['+FR_FileList.Selected.Caption+']';
        he.show;
{        while b=FALSE do begin
          self.Repaint;
          for l:=0 to $ffffffff do;
        end;
        Freemem(p,sz);}
      end;
    end else begin
      r:=FR_FileList.Selected.Data;
      if r<>NIL then begin
        hp:=0;
        while L_Hex[hp].notready do inc(hp);
        he_rdyp:=@L_Hex[hp].notready;
        he_bufl:=r^.rend-r^.rbeg+1;
        he_bufp:=@ADF^.buffb^[r^.rbeg];
        L_Hex[hp].bufp:=NIL;
        L_Hex[hp].bufl:=0;
        he:=TF_HexEdit.Create(self);
        he.Panel1.Caption:=ADF.fn+' ['+FR_FileList.Selected.Caption+']';
        he.show;
      end;
    end;
  end;
end;

procedure TDI_Inspector.FormActivate(Sender: TObject);
var b:byte;
begin
  for b:=$00 to $ff do begin
    if not L_Hex[b].notready then begin
      if (L_Hex[b].bufp<>NIL) and (L_Hex[b].bufl>0) then begin
        FreeMem(L_Hex[b].bufp,L_Hex[b].bufl);
        L_Hex[b].bufp:=NIL;
        L_Hex[b].bufl:=0;
      end;
    end;
  end;
end;

procedure TDI_Inspector.FR_DeleteClick(Sender: TObject);
var tr,r:DBE_Range;
begin
  if not closing then begin
  if FR_FileList.Selected<>NIL then begin
    if FR_FileList.Selected.Caption[1]<>'/' then begin
      r:=FR_FileList.Selected.Data;
      if r<>NIL then begin
        tr:=ranges;
        if ranges=r then begin
          ranges:=NIL;
          dispose(r);
        end else begin
          while (tr^.next<>r) and (tr^.next<>NIL) do tr:=tr^.next;
          tr^.next:=r^.next;
          dispose(r);
        end;
        DrawFileList(files,ranges,FR_FileList);
      end;
    end;
  end;
  end;
end;

procedure TDI_Inspector.FR_HexEdClick(Sender: TObject);
var f:DBE_File;
    r:DBE_Range;
    blocks:array[0..1759] of byte;
    p:pointer;
    sz:longword;
    l:longword;
    he:TF_HexEdit;
    b:boolean;
    hp:byte;
begin
  if not closing then begin
  if FR_FileList.Selected<>NIL then begin
    if FR_FileList.Selected.Caption[1]='/' then begin
      f:=FR_FileList.Selected.Data;
      if f<>NIL then begin
        LoadFile(self,f,p,sz,@blocks);
        hp:=0;
        while L_Hex[hp].notready do inc(hp);
        he_rdyp:=@L_Hex[hp].notready;
        he_bufl:=sz;
        he_bufp:=p;
        L_Hex[hp].bufp:=p;
        L_Hex[hp].bufl:=sz;
        he:=TF_HexEdit.Create(self);
        he.Panel1.Caption:=ADF.fn+' ['+FR_FileList.Selected.Caption+']';
        he.show;
{        while b=FALSE do begin
          self.Repaint;
          for l:=0 to $ffffffff do;
        end;
        Freemem(p,sz);}
      end;
    end else begin
      r:=FR_FileList.Selected.Data;
      if r<>NIL then begin
        hp:=0;
        while L_Hex[hp].notready do inc(hp);
        he_rdyp:=@L_Hex[hp].notready;
        he_bufl:=r^.rend-r^.rbeg+1;
        he_bufp:=@ADF^.buffb^[r^.rbeg];
        L_Hex[hp].bufp:=NIL;
        L_Hex[hp].bufl:=0;
        he:=TF_HexEdit.Create(self);
        he.Panel1.Caption:=ADF.fn+' ['+FR_FileList.Selected.Caption+']';
        he.show;
      end;
    end;
  end;
  end;
end;

procedure TDI_Inspector.SI_DefineMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  SI_Define.Hint:=
    'Defining a range:'+#$0a#$0d+
    '1. Select start block'+#$0a#$0d+
    '2. Click this icon'+#$0a#$0d+
    '3. Select end block'+#$0a#$0d+
    '4. Click this icon again';
end;

procedure TDI_Inspector.PopupClick(Sender:TOBject);
var TFD:TF_DiskEdit;
    TMI:TMenuItem;
    itn:longword;
    DBER:DBE_Range;
    DBEF:DBE_File;
    DBF:DB_File;
    DBR:DB_Range;
begin
  TMI:=Pointer(Sender);
  TFD:=Pointer(TMI.Tag);
  for itn:=0 to FR_FileList.Items.Count-1 do begin
    if FR_FileList.Items.Item[itn].Selected then begin
      if FR_FileList.Items.Item[itn].Caption[1]='@' then begin
        DBER:=FR_FileList.Items.Item[itn].Data;
        if TFD.DB^.ranges=NIL then begin
          New(TFD.DB^.ranges);
          DBR:=TFD.DB^.ranges;
        end else begin
          DBR:=TFD.DB^.ranges;
          while DBR^.next<>NIL do DBR:=DBR.next;
          New(DBR^.next);
          DBR:=DBR^.next;
        end;
        fillchar(DBR^,sizeof(DBR^),0);
        DBR^.addr1:=DBER^.RBeg;
        DBR^.addr2:=DBER^.REnd;
        DBR^.crc32:=DBER^.CRC32;
        DBR^.info:=DBI_GAME;
      end else begin
        DBEF:=FR_FileList.Items.Item[itn].Data;
        if TFD.DB^.files=NIL then begin
          New(TFD.DB^.files);
          DBF:=TFD.DB^.files;
        end else begin
          DBF:=TFD.DB^.files;
          while DBF^.next<>NIL do DBF:=DBF.next;
          New(DBF^.next);
          DBF:=DBF^.next;
        end;
        fillchar(DBF^,sizeof(DBF^),0);
        if StringsMatch('/s/startup-sequence',DBEF^.Name) then DBF^.info:=DBI_BOOT else
        if StringsMatch('/c/*',DBEF^.Name) then DBF^.info:=DBI_PREGAME or DBI_SHARED or DBI_EXCLUDE else
        if StringsMatch('/libs/*',DBEF^.Name) then DBF^.info:=DBI_GAME or DBI_SUBCODE or DBI_SHARED or DBI_EXCLUDE else
        if StringsMatch('/devs/system-configuration',DBEF^.Name) then DBF^.info:=DBI_PREGAME or DBI_OPTIONAL or DBI_EXCLUDE else
        if StringsMatch('/devs/*',DBEF^.Name) then DBF^.info:=DBI_UNUSED or DBI_SHARED or DBI_OPTIONAL or DBI_EXCLUDE else
        DBF^.info:=DBI_GAME;
        SetPSString(DBF^.filename,DBEF^.Name);
        DBF^.size:=DBEF^.Size;
        DBF^.crc32:=DBEF^.CRC32;
      end;
    end;
  end;
  TFD.RecordsToScreen;
{  SetPSString(TFD.DB^.diskname,'EDITED!');
  TFD.ED_Name.Text:='EDITED!';}
end;

procedure TDI_Inspector.FR_AddDatClick(Sender: TObject);
var TMI:TMenuItem;
    b:byte;
    dn:byte;
    DBD:DB_Disk;
begin
  PU_AddDat.Items.Clear;
  for b:=$00 to $ff do begin
    if (L_DiskEdit[b].inst<>NIL) and (not L_DiskEdit[b].ready) then begin
      DBD:=L_DiskEdit[b].parent^.disks;
      dn:=1;
      while (DBD<>L_DiskEdit[b].db) do begin
        DBD:=DBD.Next;
        inc(dn);
      end;
      TMI:=TMenuItem.Create(Self);
      TMI.Caption:=GetPSString(L_DiskEdit[b].parent^.gamename)+' / '+
                   'Disk #'+IntToStr(dn)+': '+GetPSString(DBD^.comment);
      TMI.OnClick:=PopupClick;
      TMI.Tag:=LongWord(L_DiskEdit[b].inst);
      PU_AddDat.Items.Add(TMI);
    end;
  end;
  PU_AddDat.Popup(FR_AddDat.ClientOrigin.X,FR_AddDat.ClientOrigin.Y);
end;

end.
